# generated by datamodel-codegen:
#   filename:  https://demo.mediascout.ru/swagger/v1/swagger.json
#   timestamp: 2024-10-04T11:24:58+00:00

from __future__ import annotations

from datetime import date, datetime
from enum import Enum
from typing import Any, Dict, List, Optional
from uuid import UUID

from pydantic import BaseModel, Extra, Field


def capitalize(s: str) -> str:
    return s[0].upper() + s[1:]


class Severity(Enum):
    Error = 'Error'
    Warning = 'Warning'
    Info = 'Info'


class ClientRelationshipType(Enum):
    DirectClient = 'DirectClient'
    InitialContractClient = 'InitialContractClient'


class LegalForm(Enum):
    JuridicalPerson = 'JuridicalPerson'
    IndividualEntrepreneur = 'IndividualEntrepreneur'
    PhysicalPerson = 'PhysicalPerson'
    InternationalJuridicalPerson = 'InternationalJuridicalPerson'
    InternationalPhysicalPerson = 'InternationalPhysicalPerson'


class CounterpartyStatus(Enum):
    Created = 'Created'
    RegistrationRequired = 'RegistrationRequired'
    Registering = 'Registering'
    Active = 'Active'
    RegistrationError = 'RegistrationError'
    Blocked = 'Blocked'


class PlatformType(Enum):
    Site = 'Site'
    Application = 'Application'
    InformationSystem = 'InformationSystem'


class TargetAudienceParamType(Enum):
    Geo = 'geo'
    Sex = 'sex'
    Age = 'age'


class CampaignType(Enum):
    CPM = 'CPM'
    CPC = 'CPC'
    CPA = 'CPA'
    Other = 'Other'


class FileType(Enum):
    Image = 'Image'
    Video = 'Video'
    Audio = 'Audio'
    Zip = 'Zip'
    Other = 'Other'
    # временная заглушка для подавления бага в АПИ МС
    Zero = 0


class ActionType(Enum):
    Add = 'Add'
    Edit = 'Edit'
    Delete = 'Delete'


class Stage(Enum):
    EntityHeader = 'EntityHeader'
    First = 'First'
    Second = 'Second'


class CreativeForm(Enum):
    Banner = 'Banner'
    Text = 'Text'
    TextGraphic = 'TextGraphic'
    Video = 'Video'
    Audio = 'Audio'
    AudioBroadcast = 'AudioBroadcast'
    VideoBroadcast = 'VideoBroadcast'
    Other = 'Other'
    TextVideoBlock = 'TextVideoBlock'
    TextAudioBlock = 'TextAudioBlock'
    TextAudioVideoBlock = 'TextAudioVideoBlock'
    TextGraphicVideoBlock = 'TextGraphicVideoBlock'
    TextGraphicAudioBlock = 'TextGraphicAudioBlock'
    TextGraphicAudioVideoBlock = 'TextGraphicAudioVideoBlock'
    BannerHtml5 = 'BannerHtml5'


class ContractStatus(Enum):
    Created = 'Created'
    RegistrationRequired = 'RegistrationRequired'
    Registering = 'Registering'
    Active = 'Active'
    RegistrationError = 'RegistrationError'
    Testing = 'Testing'
    DeletionRequired = 'DeletionRequired'
    Deleting = 'Deleting'
    DeletionError = 'DeletionError'
    Deleted = 'Deleted'


class ContractType(Enum):
    ServiceAgreement = 'ServiceAgreement'
    MediationContract = 'MediationContract'
    AdditionalAgreement = 'AdditionalAgreement'
    SelfPromotionContract = 'SelfPromotionContract'
    VirtualFinalContract = 'VirtualFinalContract'
    EcidContract = 'EcidContract'


class ContractSubjectType(Enum):
    Distribution = 'Distribution'
    OrgDistribution = 'OrgDistribution'
    Representation = 'Representation'
    Mediation = 'Mediation'
    Other = 'Other'


class DeleteContractKind(Enum):
    FinalContract = 'FinalContract'
    InitialContract = 'InitialContract'
    OuterContract = 'OuterContract'


class MediationActionType(Enum):
    Contracting = 'Contracting'
    Distribution = 'Distribution'
    CommercialRepresentation = 'CommercialRepresentation'
    Other = 'Other'


class CreativeStatus(Enum):
    Creating = 'Creating'
    Created = 'Created'
    RegistrationRequired = 'RegistrationRequired'
    Registering = 'Registering'
    Active = 'Active'
    RegistrationError = 'RegistrationError'
    DeletionRequired = 'DeletionRequired'
    Deleting = 'Deleting'
    DeletionError = 'DeletionError'
    Deleted = 'Deleted'


class InvoicePartyRole(Enum):
    Rr = 'Rr'
    Ors = 'Ors'
    Rd = 'Rd'
    Ra = 'Ra'


class InvoicelessPeriodStatus(Enum):
    Creating = 'Creating'
    RegistrationRequired = 'RegistrationRequired'
    Registering = 'Registering'
    Active = 'Active'
    RegistrationError = 'RegistrationError'


class InvoiceStatus(Enum):
    Creating = 'Creating'
    Created = 'Created'
    RegistrationRequired = 'RegistrationRequired'
    Transferring = 'Transferring'
    Registering = 'Registering'
    Active = 'Active'
    RegistrationError = 'RegistrationError'
    DeletionRequired = 'DeletionRequired'
    DeletionTransferring = 'DeletionTransferring'
    Deleting = 'Deleting'
    DeletionError = 'DeletionError'
    Deleted = 'Deleted'


class ProblemDetails(BaseModel):
    type: Optional[str] = Field(
        None,
        description='Ссылка URI [RFC3986], идентифицирующая\r\n'
        'тип ошибки. Данная спецификация рекомендует, чтобы при\r\n'
        'ссылке на него предоставлялась документация по\r\n'
        'типу ошибки. Когда\r\n'
        'этот элемент отсутствует, его значение предполагается равным\r\n'
        '«about:blank».',
    )
    title: Optional[str] = Field(
        None,
        description='Краткое описание типа ошибки. Оно НЕ ДОЛЖНО меняться от случая к случаю\r\n'
        'ошибки, за исключением целей локализации (например, при использовании\r\n'
        'проактивного согласования содержимого',
    )
    status: Optional[int] = Field(
        None, description='Код состояния HTTP сгенерированный сервером для данного случая возникновения ошибки.'
    )
    detail: Optional[str] = Field(None, description='Детальное описание ошибки')
    instance: Optional[str] = Field(
        None, description='Ссылка URI, идентифицирующая конкретное\r\nвозникновение ошибки.'
    )
    traceId: Optional[str] = Field(
        None,
        description='Идентификатор запроса. Значение атрибута TraceId необходимо использовать при взаимодействии с '
        'техподдержкой ОРД Медиаскаут. Данное поле содержит в себе идентификатор логов текущего процесса.',
        example='00-982607166a542147b435be3a847ddd71-fc75498eb9f09d48-00',
    )


class ValidationFailure(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    propertyName: Optional[str] = None
    errorMessage: Optional[str] = None
    attemptedValue: Optional[Any] = None
    customState: Optional[Any] = None
    severity: Optional[Severity] = None
    errorCode: Optional[str] = None
    formattedMessagePlaceholderValues: Optional[Dict[str, Any]] = None


class BadRequestResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    errorType: str = Field(..., description='Тип ошибки.', example='Unauthorized')
    traceId: Optional[str] = Field(
        None,
        description='Идентификатор запроса. Значение атрибута TraceId необходимо использовать при взаимодействии с '
        'техподдержкой ОРД Медиаскаут. Данное поле содержит в себе идентификатор логов текущего процесса.',
        example='00-982607166a542147b435be3a847ddd71-fc75498eb9f09d48-00',
    )
    errorItems: List[ValidationFailure] = Field(..., description='Список ошибок.', example=['Unauthorized'])


class ClearInvoiceDataWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: Optional[str] = Field(None, description='Идентификатор акта')


class CreateClientRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    createMode: Optional[ClientRelationshipType] = Field(None, description='Тип отношения заказчика к агентству')
    legalForm: LegalForm = Field(
        ...,
        description='Юридическая форма заказчика<p>Members:</p>'
        '<ul><li><i>JuridicalPerson</i> - Юрлицо РФ</li>'
        '<li><i>IndividualEntrepreneur</i> - Индивидуальный предприниматель РФ</li>'
        '<li><i>PhysicalPerson</i> - Физлицо РФ</li>'
        '<li><i>InternationalJuridicalPerson</i> - Иностранное юрлицо</li>'
        '<li><i>InternationalPhysicalPerson</i> - Иностранное физлицо</li></ul>',
    )
    inn: str = Field(
        ...,
        description='Для РФ-контрагентов - ИНН. Для иностранных физ.и юр.лиц - номер налогоплательщика '
        'либо его аналог в стране регистрации',
        example='1234567890',
    )
    name: str = Field(..., description='Наименование контрагента', example='Наименование контрагента')
    mobilePhone: Optional[str] = Field(None, description='Номер мобильного телефона', example='79999999999')
    epayNumber: Optional[str] = Field(None, description='Номер электронного средства платежа')
    regNumber: Optional[str] = Field(None, description='Регистрационный номер либо его аналог')
    oksmNumber: Optional[str] = Field(None, description='Код страны регистрации юр. лица в соответствии с ОКСМ')


class CreateFinalContractRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    number: Optional[str] = Field(
        None,
        description='Номер договора, без начального символа № и т.п. Допускается null, в таком случае считаем, '
        'что договор без номера',
        example='Тест',
    )
    date: date = Field(..., description='Дата заключения договора', example='2023-04-01')
    expirationDate: Optional[date] = Field(
        None, description='Дата окончания срока действия договора', example='2023-05-01'
    )
    amount: Optional[float] = Field(None, description='Стоимость услуг по договору в руб.', example=100)
    isAgentActingForPublisher: Optional[bool] = Field(
        None, description='Направление денежных средств в сторону заказчика', example=True
    )
    type: ContractType = Field(
        ...,
        description='Значение из справочника "Типы договоров"<p>Members:</p><ul><li><i>ServiceAgreement</i> - Договор оказания услуг</li><li><i>MediationContract</i> - Посреднический договор</li><li><i>AdditionalAgreement</i> - Дополнительное соглашение к основному договору</li><li><i>SelfPromotionContract</i> - Самореклама</li><li><i>VirtualFinalContract</i> - Служебный договор, не доступен для создания ни через интерфейсе, ни через WebApi, не передается в ЕРИР</li><li><i>EcidContract</i> - Договор, про который мы знаем только его ecid; не может быть родительским договором, дополнительным соглашением и т.д.; не регистрируется в ЕРИР</li></ul>',
    )
    subjectType: Optional[ContractSubjectType] = Field(
        None, description='Значение из справочника "Сведения о предмете договора"'
    )
    actionType: Optional[MediationActionType] = Field(
        None, description='Значение из справочника "Типы взаимодействия сторон посреднического договора"'
    )
    parentMainContractId: Optional[str] = Field(
        None, description='Id основного договора для доп.соглашения', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    clientId: str = Field(
        ..., description='Id контрагента-заказчика по доходному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    partnerId: Optional[str] = Field(None, description='Id партнера', example='CLhOO5UT6sIk-fIRu-QEsEuQ')
    date: Optional[date] = Field(None, description='Дата заключения договора', example='2023-04-01')


class CreateInitialContractRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    number: Optional[str] = Field(
        None,
        description='Номер договора, без начального символа № и т.п. Допускается null, в таком случае считаем, '
        'что договор без номера',
        example='Тест',
    )
    expirationDate: Optional[date] = Field(
        None, description='Дата окончания срока действия договора', example='2023-05-01'
    )
    amount: Optional[float] = Field(None, description='Стоимость услуг по договору в руб.', example=100)
    isAgentActingForPublisher: Optional[bool] = Field(
        None, description='Направление денежных средств в сторону заказчика', example=True
    )
    type: ContractType = Field(
        ...,
        description='Значение из справочника "Типы договоров"<p>Members:</p>'
        '<ul><li><i>ServiceAgreement</i> - Договор оказания услуг</li>'
        '<li><i>MediationContract</i> - Посреднический договор</li>'
        '<li><i>AdditionalAgreement</i> - Дополнительное соглашение к основному договору</li>'
        '<li><i>SelfPromotionContract</i> - Самореклама</li>'
        '<li><i>VirtualFinalContract</i> - Служебный договор, не доступен для создания ни через интерфейсе, '
        'ни через WebApi, не передается в ЕРИР</li>'
        '<li><i>EcidContract</i> - Договор, про который мы знаем только его ecid; не может быть '
        'родительским договором, дополнительным соглашением и т.д.; не регистрируется в ЕРИР</li></ul>',
    )
    subjectType: Optional[ContractSubjectType] = Field(
        None, description='Значение из справочника "Сведения о предмете договора"'
    )
    actionType: Optional[MediationActionType] = Field(
        None, description='Значение из справочника "Типы взаимодействия сторон посреднического договора"'
    )
    parentMainContractId: Optional[str] = Field(
        None, description='Id основного договора для доп.соглашения', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    contractorId: str = Field(
        ..., description='Id контрагента-исполнителя по изначальному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    clientId: str = Field(
        ..., description='Id контрагента-заказчика по изначальному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    finalContractId: str = Field(
        ..., description='Id или Cid доходного договора', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    date: date = Field(..., description='Дата заключения договора', example='2023-04-01')


class CreateOuterContractRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    number: Optional[str] = Field(
        None,
        description='Номер договора, без начального символа № и т.п. Допускается null, в таком случае считаем, '
        'что договор без номера',
        example='Тест',
    )
    expirationDate: Optional[date] = Field(
        None, description='Дата окончания срока действия договора', example='2023-05-01'
    )
    amount: Optional[float] = Field(None, description='Стоимость услуг по договору в руб.', example=100)
    isAgentActingForPublisher: Optional[bool] = Field(
        None, description='Направление денежных средств в сторону заказчика', example=True
    )
    type: ContractType = Field(
        ...,
        description='Значение из справочника "Типы договоров"<p>Members:</p>'
        '<ul><li><i>ServiceAgreement</i> - Договор оказания услуг</li>'
        '<li><i>MediationContract</i> - Посреднический договор</li>'
        '<li><i>AdditionalAgreement</i> - Дополнительное соглашение к основному договору</li>'
        '<li><i>SelfPromotionContract</i> - Самореклама</li>'
        '<li><i>VirtualFinalContract</i> - Служебный договор, не доступен для создания ни через интерфейсе, '
        'ни через WebApi, не передается в ЕРИР</li>'
        '<li><i>EcidContract</i> - Договор, про который мы знаем только его ecid; не может быть '
        'родительским договором, дополнительным соглашением и т.д.; не регистрируется в ЕРИР</li></ul>',
    )
    subjectType: Optional[ContractSubjectType] = Field(
        None, description='Значение из справочника "Сведения о предмете договора"'
    )
    actionType: Optional[MediationActionType] = Field(
        None, description='Значение из справочника "Типы взаимодействия сторон посреднического договора"'
    )
    parentMainContractId: Optional[str] = Field(
        None, description='Id основного договора для доп.соглашения', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    contractorId: str = Field(
        ..., description='Id контрагента-исполнителя по изначальному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    partnerId: Optional[str] = Field(None, description='Id партнера', example='CLhOO5UT6sIk-fIRu-QEsEuQ')
    isRegReport: bool = Field(
        ...,
        description='Признак того, что исполнитель по договору (Агентство, к которому относится договор) должен '
        'регистрировать креативы и предоставлять разаллокацию по ним в актах',
    )
    date: date = Field(..., description='Дата заключения договора', example='2023-04-01')


class CreatePlatformRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    name: str = Field(..., description='Наименование площадки', example='Тестовая площадка')
    type: PlatformType = Field(
        ...,
        description='Тип площадки<p>Members:</p><ul><li><i>Site</i> - Сайт</li><li><i>Application</i> - Приложение</li><li><i>InformationSystem</i> - Информационная система, не поддерживается начиная с ЕРИР v.5</li></ul>',
    )
    url: Optional[str] = Field(None, description='Url площадки', example='https://example.com')
    isOwner: bool = Field(..., description='Признак принадлежности агентству')


class CreativeMediaDataItem(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: str = Field(..., description='Идентификатор медиаданных')
    # Пока закомментирован вариант по swagger.json МС
    # так как оказалось у нас есть креативы с медиаданными, но в МС поле fileName пустое
    # из-за чего запрос такого креатива падает на обработке ответа в pydantic
    # fileName: str = Field(
    #     ...,
    #     description='Имя файла\r\n<p style="color: blue">Поле обязательно для заполнения</p>', example='file.txt'
    # )
    fileName: Optional[str] = Field(
        None,
        description='Имя файла\r\n<p style="color: blue">Поле обязательно для заполнения</p>', example='file.txt'
    )
    fileType: Optional[FileType] = Field(
        None,
        description='Тип файла медиаданных креатива<p>Members:</p><ul><li><i>Image</i> - Изображение</li><li><i>Video</i> - Видео</li><li><i>Audio</i> - Аудио</li><li><i>Zip</i> - Архив</li><li><i>Other</i> - Иное</li></ul>',
        example='image',
    )
    description: Optional[str] = Field(
        None,
        description='Описание изображения креатива\r\n<p style="color: blue">Поле условно-обязательно для заполнения. '
        'Обязательно для `fileType = image`</p>',
        example='Описание',
    )


class CreateCreativeMediaDataItem(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: Optional[str] = Field(None, description='Идентификатор медиаданных')
    fileName: str = Field(
        ..., description='Имя файла\r\n<p style="color: blue">Поле обязательно для заполнения</p>', example='file.txt'
    )
    fileType: FileType = Field(
        ...,
        description='Тип файла медиаданных креатива\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
        '<p>Members:'
        '</p><ul><li><i>Image</i> - Изображение</li>'
        '<li><i>Video</i> - Видео</li>'
        '<li><i>Audio</i> - Аудио</li>'
        '<li><i>Zip</i> - Архив</li>'
        '<li><i>Other</i> - Иное</li></ul>',
        example='image',
    )
    fileContentBase64: Optional[str] = Field(
        None,
        description='Содержимое файла в кодировке Base64\r\n<p style="color: blue">Поле условно-обязательно для '
        'заполнения. Обязательно, если не заполнено поле `srcUrl`</p>',
    )
    srcUrl: Optional[str] = Field(
        None,
        description='URL, откуда можно скачать файл. URL должен быть доступен без авторизации\r\n'
        '<p style="color: blue">Поле условно-обязательно для заполнения. Обязательно, '
        'если не заполнено поле `fileContentBase64`</p>',
        example='https://example.com',
    )
    isArchive: bool = Field(
        ...,
        description='Признак того, что это архив\r\n<p style="color: lightblue">Поле не обязательно для заполнения. '
        'Если не заполнено, устанавливается значение `false`</p>',
    )


class EditCreativeMediaDataItem(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: Optional[str] = Field(
        None,
        description='Идентификатор текстовых медиаданных\r\n<p style="color: lightblue">Поле условно-обязательно для '
        'заполнения. Обязательно для `ActionType` = `Edit` или `Delete`</p>',
    )
    actionType: Optional[ActionType] = Field(
        None,
        description='Тип действия над медиаданными\r\n<p style="color: lightblue">Поле условно-обязательно для '
        'заполнения. Если не заполнено, будет установлено значение `Add`</p>',
    )
    fileName: Optional[str] = Field(
        None,
        description='Имя файла\r\n<p style="color: lightblue">Поле условно-обязательно для заполнения. '
        'Обязательно для `ActionType` = `Add`</p>',
        example='file.txt',
    )
    fileType: Optional[FileType] = Field(
        None,
        description='Тип файла медиаданных креатива\r\n<p style="color: lightblue">Поле условно-обязательно для '
        'заполнения. Обязательно для `ActionType` = `Add` или `Edit`</p>',
        example='image',
    )
    fileContentBase64: Optional[str] = Field(
        None,
        description='Содержимое файла в кодировке Base64\r\n<p style="color: blue">Поле условно-обязательно для '
        'заполнения. Обязательно, если не заполнено поле `srcUrl` и `ActionType` = `Add`</p>',
    )
    srcUrl: Optional[str] = Field(
        None,
        description='URL, откуда можно скачать файл. URL должен быть доступен без авторизации\r\n'
        '<p style="color: blue">Поле условно-обязательно для заполнения. Обязательно, '
        'если не заполнено поле `fileContentBase64` и `ActionType` = `Add`</p>',
        example='https://example.com',
    )
    isArchive: bool = Field(
        ...,
        description='Признак того, что это архив\r\n<p style="color: lightblue">Поле не обязательно для заполнения. '
        'Если не заполнено, устанавливается значение `false`. '
        'Имеет смысл только для `ActionType` = `Add`</p>',
    )


class EditCreativeTextDataItem(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: Optional[str] = Field(
        None,
        description='Идентификатор текстовых медиаданных\r\n<p style="color: lightblue">Поле условно-обязательно для '
        'заполнения. Обязательно для `ActionType` = `Edit` или `Delete`</p>',
    )
    actionType: Optional[ActionType] = Field(
        None,
        description='Тип действия над медиаданными\r\n<p style="color: lightblue">Поле условно-обязательно для '
        'заполнения. Если не заполнено, будет установлено значение `Add`</p>',
    )
    textData: Optional[str] = Field(
        None,
        description='Текстовые данные креатива\r\n<p style="color: lightblue">Поле условно-обязательно для заполнения. '
        'Обязательно для `ActionType` = `Add` или `Edit`</p>',
        example='Некий текст',
    )


class CreateCreativeTextDataItem(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    textData: str = Field(
        ...,
        description='Текстовые данные креатива\r\n<p style="color: blue">Поле обязательно для заполнения</p>',
        example='Некий текст',
    )


class CreativeTextDataItemWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: str = Field(..., description='Идентификатор медиаданных')
    textData: str = Field(..., description='Текстовые данные креатива')


class CreatedCreativeResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: str = Field(..., description='Id креатива')
    nativeCustomerId: Optional[str] = Field(None, description='Id креатива в системе клиента')
    erid: str = Field(..., description='Erid креатива')
    creativeGroupId: str = Field(..., description='Id брони (группы) креативов')
    creativeGroupName: str = Field(..., description='Наименование брони (группы) креативов')
    mediaData: List[CreativeMediaDataItem] = Field(..., description='Файловые медиаданные креатива')
    textData: List[CreativeTextDataItemWebApiDto] = Field(..., description='Текстовые медиаданные креатива')


class DeleteContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    contractId: str = Field(..., description='Id удаляемого договора')
    finalContractId: Optional[str] = Field(
        None, description='Идентификатор доходного договора. Заполняется только при удалении изначального договора.'
    )
    contractKind: DeleteContractKind = Field(
        ...,
        description='Вид удаляемой связи (т.е. чем этот договор был - конечным, изначальным, внешним для агентства)'
        '<p>Members:</p>'
        '<ul><li><i>FinalContract</i> - Конечный договор</li>'
        '<li><i>InitialContract</i> - Изначальный договор</li>'
        '<li><i>OuterContract</i> - Внешний договор</li></ul>',
    )


class DeleteRestoreCreativeWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    erid: Optional[str] = Field(None, description='Фильтр по маркеру креатива')
    nativeCustomerId: Optional[str] = Field(None, description='Пользовательский Id креатива')


class EditCreativeRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: Optional[str] = Field(
        None,
        description='Id креатива. Должно быть заполнено либо Id креатива, либо NativeCustomerId, либо Erid\r\n'
        '<p style="color: blue">Поле условно-обязательно для заполнения. Не должно заполняться '
        'одновременно с полями `NativeCustomerId`, `Erid`</p>',
        example='CR5pxRa__aRkSgUqt0JeNkoA',
    )
    nativeCustomerId: Optional[str] = Field(
        None,
        description='Id креатива в системе клиента\r\n<p style="color: blue">Поле условно-обязательно для заполнения. '
        'Не должно заполняться одновременно с полями `Id`, `Erid`</p>',
    )
    erid: Optional[str] = Field(
        None,
        description='Erid креатива\r\n<p style="color: blue">Поле условно-обязательно для заполнения. Не должно '
        'заполняться одновременно с полями `Id`, `NativeCustomerId`</p>',
        example='2SDnjcX1BkW',
    )
    creativeGroupId: Optional[str] = Field(
        None,
        description='Id брони, если пусто, значит - создаем новую бронь, иначе добавляем в существующую. При этом '
        'бронь остается текущая или все поля новой брони обязаны совпадать с текущей\r\n'
        '<p style="color: lightblue">Поле не обязательно для заполнения</p>',
    )
    creativeGroupName: Optional[str] = Field(
        None,
        description='Наименование создаваемой брони, заполняется только если CreativeGroupId = NULL\r\n'
        '<p style="color: blue">Поле условно-обязательно для заполнения</p>',
        example='ТестоваяГруппа',
    )
    creativeGroupStartDate: Optional[date] = Field(
        None,
        description='Дата начала рекламной компании\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
        example='2023-01-01',
    )
    creativeGroupEndDate: Optional[date] = Field(
        None,
        description='Дата окончания рекламной компании\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
        example='2023-30-01',
    )
    advertiserUrls: List[str] = Field(
        ...,
        description='Целевые ссылки (сайты рекламодателя, на который осуществляется переход с креатива)\r\nПроверка URL:\r\n<ul><li>Проверить протокол http, https, ftp, sftp</li><li>Проверить хост: в нем не должно содержаться punycode или urlencode</li></ul><p style="color: lightblue">Поле не обязательно для заполнения</p>',
        example=['http://test1.ru', 'http://test2.ru'],
    )
    overwriteExistingCreativeMedia: bool = Field(
        ...,
        description='Перезаписать все предыдущие медиаданные креатива (файловые и текстовые). Токен останется прежним, существующие медиаданные удалятся, переданные медиаданые запишутся.\r\n<p style="color: lightblue">Поле не обязательно для заполнения. Если не заполнено, устанавливается значение `false`</p>',
    )
    mediaData: Optional[List[EditCreativeMediaDataItem]] = Field(
        None,
        description='Медиаданные креатива (массив)\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
    )
    textData: Optional[List[EditCreativeTextDataItem]] = Field(
        None,
        description='Текстовые медиаданные креатива (массив)\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
    )

# EditFinalContractRequest
class EditFinalContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    date: date = Field(..., description='Дата заключения договора', example='2023-04-01')
    number: Optional[str] = Field(
        None,
        description='Номер договора, без начального символа № и т.п. Допускается null, в таком случае считаем, '
        'что договор без номера',
        example='Тест',
    )
    expirationDate: Optional[date] = Field(
        None, description='Дата окончания срока действия договора', example='2023-05-01'
    )
    amount: Optional[float] = Field(None, description='Стоимость услуг по договору в руб.', example=100)
    isAgentActingForPublisher: Optional[bool] = Field(
        None, description='Направление денежных средств в сторону заказчика', example=True
    )
    type: ContractType = Field(
        ...,
        description='Значение из справочника "Типы договоров"<p>Members:</p>'
        '<ul><li><i>ServiceAgreement</i> - Договор оказания услуг</li>'
        '<li><i>MediationContract</i> - Посреднический договор</li>'
        '<li><i>AdditionalAgreement</i> - Дополнительное соглашение к основному договору</li>'
        '<li><i>SelfPromotionContract</i> - Самореклама</li>'
        '<li><i>VirtualFinalContract</i> - Служебный договор, не доступен для создания ни через '
        'интерфейсе, ни через WebApi, не передается в ЕРИР</li>'
        '<li><i>EcidContract</i> - Договор, про который мы знаем только его ecid; не может быть '
        'родительским договором, дополнительным соглашением и т.д.; не регистрируется в ЕРИР</li></ul>',
    )
    subjectType: Optional[ContractSubjectType] = Field(
        None, description='Значение из справочника "Сведения о предмете договора"'
    )
    actionType: Optional[MediationActionType] = Field(
        None, description='Значение из справочника "Типы взаимодействия сторон посреднического договора"'
    )
    parentMainContractId: Optional[str] = Field(
        None, description='Id основного договора для доп.соглашения', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    clientId: str = Field(
        ..., description='Id контрагента-заказчика по доходному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    partnerId: Optional[str] = Field(None, description='Id партнера', example='CLhOO5UT6sIk-fIRu-QEsEuQ')


# EditInitialContractRequest
class EditInitialContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    number: Optional[str] = Field(
        None,
        description='Номер договора, без начального символа № и т.п. Допускается null, в таком случае считаем, что договор без номера',
        example='Тест',
    )
    date: date = Field(..., description='Дата заключения договора', example='2023-04-01')
    expirationDate: Optional[date] = Field(
        None, description='Дата окончания срока действия договора', example='2023-05-01'
    )
    amount: Optional[float] = Field(None, description='Стоимость услуг по договору в руб.', example=100)
    isAgentActingForPublisher: Optional[bool] = Field(
        None, description='Направление денежных средств в сторону заказчика', example=True
    )
    type: ContractType = Field(
        ...,
        description='Значение из справочника "Типы договоров"<p>Members:</p><ul><li><i>ServiceAgreement</i> - Договор оказания услуг</li><li><i>MediationContract</i> - Посреднический договор</li><li><i>AdditionalAgreement</i> - Дополнительное соглашение к основному договору</li><li><i>SelfPromotionContract</i> - Самореклама</li><li><i>VirtualFinalContract</i> - Служебный договор, не доступен для создания ни через интерфейсе, ни через WebApi, не передается в ЕРИР</li><li><i>EcidContract</i> - Договор, про который мы знаем только его ecid; не может быть родительским договором, дополнительным соглашением и т.д.; не регистрируется в ЕРИР</li></ul>',
    )
    subjectType: Optional[ContractSubjectType] = Field(
        None, description='Значение из справочника "Сведения о предмете договора"'
    )
    actionType: Optional[MediationActionType] = Field(
        None, description='Значение из справочника "Типы взаимодействия сторон посреднического договора"'
    )
    parentMainContractId: Optional[str] = Field(
        None, description='Id основного договора для доп.соглашения', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    contractorId: str = Field(
        ..., description='Id контрагента-исполнителя по изначальному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    clientId: str = Field(
        ..., description='Id контрагента-заказчика по изначальному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    finalContractId: str = Field(..., description='Id или Cid доходного договора', example='CT0N4ufC76TEu1xBEIwJ3CaA')


# EditInvoiceRequest
class EditInvoiceDataWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    number: Optional[str] = Field(
        None, description='Номер акта. Допускается null, в таком случае считаем, что акт без номера', example='Тест'
    )
    date: date = Field(..., description='Дата акта', example='2022-12-31')
    contractorRole: InvoicePartyRole = Field(
        ...,
        description='Роль исполнителя в акте<p>Members:</p><ul><li><i>Rr</i> - Рекламораспространитель</li><li><i>Ors</i> - Оператор рекламной системы</li><li><i>Rd</i> - Рекламодатель</li><li><i>Ra</i> - Рекламное агентство</li></ul>',
        example='Ra',
    )
    clientRole: InvoicePartyRole = Field(
        ...,
        description='Роль заказчика в акте<p>Members:</p><ul><li><i>Rr</i> - Рекламораспространитель</li><li><i>Ors</i> - Оператор рекламной системы</li><li><i>Rd</i> - Рекламодатель</li><li><i>Ra</i> - Рекламное агентство</li></ul>',
        example='Rd',
    )
    amount: float = Field(..., description='Общая стоимость по акту в руб.', example=100)
    startDate: date = Field(..., description='Дата начала оказания услуг по акту', example='2022-12-01')
    endDate: date = Field(..., description='Дата окончания оказания услуг по акту (включительно)', example='2022-12-31')
    finalContractId: str = Field(..., description='Id доходного договора в ОРД', example='CT3at_SU7y3ECdCb-AfHV3sA')


# EditOuterContractRequest
class EditOuterContractWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    number: Optional[str] = Field(
        None,
        description='Номер договора, без начального символа № и т.п. Допускается null, в таком случае считаем, '
        'что договор без номера',
        example='Тест',
    )
    date: date = Field(..., description='Дата заключения договора', example='2023-04-01')
    expirationDate: Optional[date] = Field(
        None, description='Дата окончания срока действия договора', example='2023-05-01'
    )
    amount: Optional[float] = Field(None, description='Стоимость услуг по договору в руб.', example=100)
    isAgentActingForPublisher: Optional[bool] = Field(
        None, description='Направление денежных средств в сторону заказчика', example=True
    )
    type: ContractType = Field(
        ...,
        description='Значение из справочника "Типы договоров"<p>Members:</p>'
        '<ul><li><i>ServiceAgreement</i> - Договор оказания услуг</li>'
        '<li><i>MediationContract</i> - Посреднический договор</li>'
        '<li><i>AdditionalAgreement</i> - Дополнительное соглашение к основному договору</li>'
        '<li><i>SelfPromotionContract</i> - Самореклама</li>'
        '<li><i>VirtualFinalContract</i> - Служебный договор, не доступен для создания ни через '
        'интерфейсе, ни через WebApi, не передается в ЕРИР</li>'
        '<li><i>EcidContract</i> - Договор, про который мы знаем только его ecid; не может быть '
        'родительским договором, дополнительным соглашением и т.д.; не регистрируется в ЕРИР</li></ul>',
    )
    subjectType: Optional[ContractSubjectType] = Field(
        None, description='Значение из справочника "Сведения о предмете договора"'
    )
    actionType: Optional[MediationActionType] = Field(
        None, description='Значение из справочника "Типы взаимодействия сторон посреднического договора"'
    )
    parentMainContractId: Optional[str] = Field(
        None, description='Id основного договора для доп.соглашения', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    contractorId: str = Field(
        ..., description='Id контрагента-исполнителя по изначальному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    partnerId: Optional[str] = Field(None, description='Id партнера', example='CLhOO5UT6sIk-fIRu-QEsEuQ')
    isRegReport: bool = Field(
        ...,
        description='Признак того, что исполнитель по договору (Агентство, к которому относится договор) должен '
        'регистрировать креативы и предоставлять разаллокацию по ним в актах',
    )


# EditPlatformRequest
class EditPlatformWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    name: str = Field(..., description='Наименование площадки', example='Тестовая площадка')
    type: PlatformType = Field(
        ...,
        description='Тип площадки<p>Members:</p>'
        '<ul><li><i>Site</i> - Сайт</li>'
        '<li><i>Application</i> - Приложение</li>'
        '<li><i>InformationSystem</i> - Информационная система, '
        'не поддерживается начиная с ЕРИР v.5</li></ul>',
    )
    url: Optional[str] = Field(None, description='Url площадки', example='https://example.com')
    isOwner: bool = Field(..., description='Признак принадлежности агентству')


class EntityIdResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: str = Field(..., description='Идентификатор акта', example='INUFNs1ibfg0erF1PNpTOAyg')


class ErirValidationError(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    stage: Stage = Field(
        ...,
        description='Тип запроса ЕРИР-интеграции<p>Members:</p><ul><li><i>EntityHeader</i> - Отправлена заголовочная '
        'информация (например шапка акта)</li><li><i>First</i> - Первоначальный быстрый запрос, '
        'проверяются лишь атрибуты сущности</li><li><i>Second</i> - Запрос на получение уточненных '
        'результатов логической проверки</li></ul>',
    )
    code: str = Field(..., description='Код ошибки от ЕРИР', example='I_82')
    message: str = Field(
        ..., description='Подробный текст ошибки от ЕРИР', example='В разаллокации присутствует более одного договора'
    )
    responseDt: datetime = Field(..., description='Дата-время ответа, полученного от ЕРИР')


class FiasResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: str = Field(..., description='Идентификатор адресного объекта')
    parentId: Optional[str] = Field(None, description='Идентификатор родительского объекта')
    objectGuid: UUID = Field(
        ...,
        description='Глобальный уникальный идентификатор адресного объекта типа UUID',
        example='3fa85f64-5717-4562-b3fc-2c963f66afa6',
    )
    name: str = Field(..., description='Краткое наименование типа объекта', example='город')
    fullName: str = Field(
        ..., description='Полное наименование адресного объекта', example='Нижний Новгород'
    )


class CreatedFinalContractResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    number: Optional[str] = Field(
        None,
        description='Номер договора, без начального символа № и т.п. Допускается null, в таком случае считаем, что договор без номера',
        example='Тест',
    )
    date: date = Field(..., description='Дата заключения договора', example='2023-04-01')
    expirationDate: Optional[date] = Field(
        None, description='Дата окончания срока действия договора', example='2023-05-01'
    )
    amount: Optional[float] = Field(None, description='Стоимость услуг по договору в руб.', example=100)
    isAgentActingForPublisher: Optional[bool] = Field(
        None, description='Направление денежных средств в сторону заказчика', example=True
    )
    type: ContractType = Field(
        ...,
        description='Значение из справочника "Типы договоров"<p>Members:</p><ul><li><i>ServiceAgreement</i> - Договор оказания услуг</li><li><i>MediationContract</i> - Посреднический договор</li><li><i>AdditionalAgreement</i> - Дополнительное соглашение к основному договору</li><li><i>SelfPromotionContract</i> - Самореклама</li><li><i>VirtualFinalContract</i> - Служебный договор, не доступен для создания ни через интерфейсе, ни через WebApi, не передается в ЕРИР</li><li><i>EcidContract</i> - Договор, про который мы знаем только его ecid; не может быть родительским договором, дополнительным соглашением и т.д.; не регистрируется в ЕРИР</li></ul>',
    )
    subjectType: Optional[ContractSubjectType] = Field(
        None, description='Значение из справочника "Сведения о предмете договора"'
    )
    actionType: Optional[MediationActionType] = Field(
        None, description='Значение из справочника "Типы взаимодействия сторон посреднического договора"'
    )
    parentMainContractId: Optional[str] = Field(
        None, description='Id основного договора для доп.соглашения', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    clientId: str = Field(
        ..., description='Id контрагента-заказчика по доходному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    partnerId: Optional[str] = Field(None, description='Id партнера', example='CLhOO5UT6sIk-fIRu-QEsEuQ')
    id: str = Field(..., description='Id доходного договора в ОРД', example='CT0N4ufC76TEu1xBEIwJ3CaA')
    status: ContractStatus = Field(
        ...,
        description='Статус доходного договора в ОРД<p>Members:</p><ul><li><i>Created</i> - Создан в БД (наша валидация пройдена). Пока не используется, сущность сразу переходит в статус [Ожидает регистрации].</li><li><i>RegistrationRequired</i> - Ожидает регистрации в ЕРИР</li><li><i>Registering</i> - Идет регистрация, быстрый контроль ЕРИР пройден, ждем уточненного ответа</li><li><i>Active</i> - Активный</li><li><i>RegistrationError</i> - Ошибка регистрации ЕРИР (любого этапа)</li><li><i>Testing</i> - Тестирование - для тестирования массовой загрузки креативов на продовом контуре</li><li><i>DeletionRequired</i> - Ожидает удаления в ЕРИР</li><li><i>Deleting</i> - Идет удаление, быстрый контроль ЕРИР пройден, ждем уточненного ответа</li><li><i>DeletionError</i> - Ошибка удаления в ЕРИР (любого этапа)</li><li><i>Deleted</i> - Удален в ЕРИР</li></ul>',
    )
    # TODO: вернуть, когда МС починит возврат этих полей
    # contractorId: str = Field(..., description='Id исполнителя', example='CLhOO5UT6sIk-fIRu-QEsEuQ')
    # contractorInn: str = Field(..., description='ИНН исполнителя', example='7722643959')
    # contractorName: str = Field(..., description='Наименование исполнителя', example='ООО "Ромашка"')
    #
    contractorId: Optional[str] = Field(None, description='Id исполнителя', example='CLhOO5UT6sIk-fIRu-QEsEuQ')
    contractorInn: Optional[str] = Field(None, description='ИНН исполнителя', example='7722643959')
    contractorName: Optional[str] = Field(None, description='Наименование исполнителя', example='ООО "Ромашка"')


class FinalContractResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: str = Field(..., description='Id доходного договора в ОРД', example='CT0N4ufC76TEu1xBEIwJ3CaA')
    number: Optional[str] = Field(
        None,
        description='Номер договора, без начального символа № и т.п. Допускается null, в таком случае считаем, что '
        'договор без номера',
        example='Тест',
    )
    date: date = Field(..., description='Дата заключения договора', example='2023-04-01')
    expirationDate: Optional[date] = Field(
        None, description='Дата окончания срока действия договора', example='2023-05-01'
    )
    amount: Optional[float] = Field(None, description='Стоимость услуг по договору в руб.', example=100)
    isAgentActingForPublisher: Optional[bool] = Field(
        None, description='Направление денежных средств в сторону заказчика', example=True
    )
    type: ContractType = Field(
        ...,
        description='Значение из справочника "Типы договоров"<p>Members:</p>'
        '<ul><li><i>ServiceAgreement</i> - Договор оказания услуг</li>'
        '<li><i>MediationContract</i> - Посреднический договор</li>'
        '<li><i>AdditionalAgreement</i> - Дополнительное соглашение к основному договору</li>'
        '<li><i>SelfPromotionContract</i> - Самореклама</li>'
        '<li><i>VirtualFinalContract</i> - Служебный договор, не доступен для создания ни '
        'через интерфейсе, ни через WebApi, не передается в ЕРИР</li>'
        '<li><i>EcidContract</i> - Договор, про который мы знаем только его ecid; не может быть '
        'родительским договором, дополнительным соглашением и т.д.; не регистрируется в ЕРИР</li></ul>',
    )
    subjectType: Optional[ContractSubjectType] = Field(
        None, description='Значение из справочника "Сведения о предмете договора"'
    )
    actionType: Optional[MediationActionType] = Field(
        None, description='Значение из справочника "Типы взаимодействия сторон посреднического договора"'
    )
    parentMainContractId: Optional[str] = Field(
        None, description='Id основного договора для доп.соглашения', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    clientId: str = Field(
        ..., description='Id контрагента-заказчика по доходному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    partnerId: Optional[str] = Field(None, description='Id партнера', example='CLhOO5UT6sIk-fIRu-QEsEuQ')
    status: ContractStatus = Field(
        ...,
        description='Статус доходного договора в ОРД<p>Members:</p>'
        '<ul><li><i>Created</i> - Создан в БД (наша валидация пройдена). Пока не используется, '
        'сущность сразу переходит в статус [Ожидает регистрации].</li>'
        '<li><i>RegistrationRequired</i> - Ожидает регистрации в ЕРИР</li>'
        '<li><i>Registering</i> - Идет регистрация, быстрый контроль ЕРИР пройден, '
        'ждем уточненного ответа</li>'
        '<li><i>Active</i> - Активный</li>'
        '<li><i>RegistrationError</i> - Ошибка регистрации ЕРИР (любого этапа)</li>'
        '<li><i>Testing</i> - Тестирование - для тестирования массовой загрузки креативов на продовом '
        'контуре</li>'
        '<li><i>DeletionRequired</i> - Ожидает удаления в ЕРИР</li>'
        '<li><i>Deleting</i> - Идет удаление, быстрый контроль ЕРИР пройден, ждем уточненного ответа</li>'
        '<li><i>DeletionError</i> - Ошибка удаления в ЕРИР (любого этапа)</li>'
        '<li><i>Deleted</i> - Удален в ЕРИР</li></ul>',
    )
    contractorId: str = Field(..., description='Id исполнителя', example='CLhOO5UT6sIk-fIRu-QEsEuQ')
    # TODO: вернуть, когда МС починит возврат этих полей
    # contractorInn: str = Field(..., description='ИНН исполнителя', example='7722643959')
    # contractorName: str = Field(..., description='Наименование исполнителя', example='ООО "Ромашка"')
    contractorInn: Optional[str] = Field(None, description='ИНН исполнителя', example='7722643959')
    contractorName: Optional[str] = Field(None, description='Наименование исполнителя', example='ООО "Ромашка"')
    cid: Optional[str] = Field(
        None, description='Cid доходного договора', example='763acd99-687b-46cd-8f40-45eced77413c'
    )
    erirValidationError: Optional[ErirValidationError] = None


class GetClientRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: Optional[str] = Field(None, description='Фильтр по Id заказчика в ОРД')
    inn: Optional[str] = Field(None, description='Фильтр по ИНН заказчика')
    status: Optional[CounterpartyStatus] = Field(None, description='Фильтр по статусу заказчика')


class GetCreativeGroupsRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    initialContractId: Optional[str] = Field(
        None,
        description='Фильтр по Id или Cid изначального договора изначального договора\r\n'
        '<p style="color: lightblue">Поле не обязательно для заполнения</p>',
    )
    finalContractId: Optional[str] = Field(
        None,
        description='Фильтр по Id доходного договора в ОРД\r\n'
        '<p style="color: lightblue">Поле не обязательно для заполнения</p>',
    )
    creativeGroupName: Optional[str] = Field(
        None,
        description='Фильтр по номеру доходного договора\r\n'
        '<p style="color: lightblue">Поле не обязательно для заполнения</p>',
    )
    creativeGroupStartDate: Optional[date] = Field(
        None,
        description='Дата начала рекламной компании\r\n'
        '<p style="color: lightblue">Поле не обязательно для заполнения</p>',
    )
    creativeGroupEndDate: Optional[date] = Field(
        None,
        description='Дата окончания рекламной компании\r\n'
        '<p style="color: lightblue">Поле не обязательно для заполнения</p>',
    )


class GetCreativesWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    ids: Optional[List[str]] = Field(None, description='Фильтр по Id креативов в ОРД. Поле не обязательно для заполнения')
    nativeCustomerIds: Optional[List[str]] = Field(None, description='Фильтр по пользовательским Id креативов. Поле не обязательно для заполнения')
    erids: Optional[List[str]] = Field(None, description='Фильтр по маркерам креативов. Поле не обязательно для заполнения')
    creativeGroupStartDate: Optional[date] = Field(None, description='Дата начала рекламной компании')
    creativeGroupEndDate: Optional[date] = Field(None, description='Дата окончания рекламной компании')
    initialContractId: Optional[str] = Field(None, description='Фильтр по Id или Cid изначального договора')
    initialContractNumber: Optional[str] = Field(None, description='Фильтр по номеру изначального договора')
    finalContractId: Optional[str] = Field(None, description='Фильтр по Id доходного договора в ОРД')
    finalContractNumber: Optional[str] = Field(None, description='Фильтр по номеру доходного договора')
    status: Optional[CreativeStatus] = Field(None, description='Фильтр по статусу креатива')


class GetCreativeStatusWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    creativeId: str = Field(..., description='Идентификатор креатива в ОРД')


class GetFinalContractsRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    finalContractId: Optional[str] = Field(None, description='Фильтр по Id или Cid доходного договора')
    clientId: Optional[str] = Field(None, description='Фильтр по Id контрагента-заказчика по договору в ОРД')
    status: Optional[ContractStatus] = Field(None, description='Фильтр по статусу доходного договора')


class GetInitialContractRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    initialContractId: Optional[str] = Field(None, description='Фильтр по Id или Cid изначального договора')
    finalContractId: Optional[str] = Field(None, description='Фильтр по Id или Cid доходного договора')
    contractorId: Optional[str] = Field(
        None, description='Фильтр по Id контрагента-исполнителя по изначальному договору в ОРД'
    )
    contractorInn: Optional[str] = Field(
        None, description='Фильтр по ИНН контрагента-исполнителя по изначальному договору в ОРД'
    )
    contractorName: Optional[str] = Field(
        None, description='Фильтр по наименованию контрагента-исполнителя по изначальному договору в ОРД'
    )
    clientId: Optional[str] = Field(
        None, description='Фильтр по Id контрагента-заказчика по изначальному договору в ОРД'
    )
    clientInn: Optional[str] = Field(
        None, description='Фильтр по ИНН контрагента-заказчика по изначальному договору в ОРД'
    )
    clientName: Optional[str] = Field(
        None, description='Фильтр по наименованию контрагента-заказчика по изначальному договору в ОРД'
    )
    status: Optional[ContractStatus] = Field(None, description='Фильтр по статусу изначального договора')


class GetInvoicelessPeriodsRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    dateStart: Optional[date] = Field(None, description='Начало диапазона дат периодов статистики')
    dateEnd: Optional[date] = Field(None, description='Конец диапазона дат периодов статистики')
    status: Optional[InvoicelessPeriodStatus] = Field(None, description='Фильтр по статусу акта')


class GetInvoicesWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    ids: Optional[List[str]] = Field(None, description='Фильтр по Id акта в ОРД')
    number: Optional[str] = Field(None, description='Номер акта')
    dateStart: Optional[date] = Field(None, description='Начало диапазона дат актов')
    dateEnd: Optional[date] = Field(None, description='Конец диапазона дат актов')
    finalContractId: Optional[str] = Field(None, description='Фильтр по Id доходного договора в ОРД')
    status: Optional[InvoiceStatus] = Field(None, description='Фильтр по статусу акта')


class GetOuterContractsRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    outerContractId: Optional[str] = Field(None, description='Фильтр по Id или Cid расходного договора')
    status: Optional[ContractStatus] = Field(None, description='Фильтр по статусу расходного договора')
    contractorId: Optional[str] = Field(
        None, description='Фильтр по Id контрагента-исполнителя по расходному договору в ОРД'
    )
    clientId: Optional[str] = Field(None, description='Фильтр по Id контрагента-заказчика по расходному договору в ОРД')


class CreatedInitialContractResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    number: Optional[str] = Field(
        None,
        description='Номер договора, без начального символа № и т.п. Допускается null, в таком случае считаем, что договор без номера',
        example='Тест',
    )
    date: date = Field(..., description='Дата заключения договора', example='2023-04-01')
    expirationDate: Optional[date] = Field(
        None, description='Дата окончания срока действия договора', example='2023-05-01'
    )
    amount: Optional[float] = Field(None, description='Стоимость услуг по договору в руб.', example=100)
    isAgentActingForPublisher: Optional[bool] = Field(
        None, description='Направление денежных средств в сторону заказчика', example=True
    )
    type: ContractType = Field(
        ...,
        description='Значение из справочника "Типы договоров"<p>Members:</p><ul><li><i>ServiceAgreement</i> - Договор оказания услуг</li><li><i>MediationContract</i> - Посреднический договор</li><li><i>AdditionalAgreement</i> - Дополнительное соглашение к основному договору</li><li><i>SelfPromotionContract</i> - Самореклама</li><li><i>VirtualFinalContract</i> - Служебный договор, не доступен для создания ни через интерфейсе, ни через WebApi, не передается в ЕРИР</li><li><i>EcidContract</i> - Договор, про который мы знаем только его ecid; не может быть родительским договором, дополнительным соглашением и т.д.; не регистрируется в ЕРИР</li></ul>',
    )
    subjectType: Optional[ContractSubjectType] = Field(
        None, description='Значение из справочника "Сведения о предмете договора"'
    )
    actionType: Optional[MediationActionType] = Field(
        None, description='Значение из справочника "Типы взаимодействия сторон посреднического договора"'
    )
    parentMainContractId: Optional[str] = Field(
        None, description='Id основного договора для доп.соглашения', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    contractorId: str = Field(
        ..., description='Id контрагента-исполнителя по изначальному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    clientId: str = Field(
        ..., description='Id контрагента-заказчика по изначальному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    finalContractId: str = Field(..., description='Id или Cid доходного договора', example='CT0N4ufC76TEu1xBEIwJ3CaA')
    id: str = Field(..., description='Id изначального договора в ОРД', example='CT0N4ufC76TEu1xBEIwJ3CaA')
    status: ContractStatus = Field(
        ...,
        description='Статус изначального договора в ОРД<p>Members:</p><ul><li><i>Created</i> - Создан в БД (наша валидация пройдена). Пока не используется, сущность сразу переходит в статус [Ожидает регистрации].</li><li><i>RegistrationRequired</i> - Ожидает регистрации в ЕРИР</li><li><i>Registering</i> - Идет регистрация, быстрый контроль ЕРИР пройден, ждем уточненного ответа</li><li><i>Active</i> - Активный</li><li><i>RegistrationError</i> - Ошибка регистрации ЕРИР (любого этапа)</li><li><i>Testing</i> - Тестирование - для тестирования массовой загрузки креативов на продовом контуре</li><li><i>DeletionRequired</i> - Ожидает удаления в ЕРИР</li><li><i>Deleting</i> - Идет удаление, быстрый контроль ЕРИР пройден, ждем уточненного ответа</li><li><i>DeletionError</i> - Ошибка удаления в ЕРИР (любого этапа)</li><li><i>Deleted</i> - Удален в ЕРИР</li></ul>',
    )
    # TODO: вернуть, когда МС починит возврат этих полей
    # contractorInn: str = Field(..., description='ИНН исполнителя', example='7722643959')
    # contractorName: str = Field(..., description='Наименование исполнителя', example='ООО «Ромашка»')
    # clientInn: str = Field(..., description='ИНН заказчика', example='7722643959')
    # clientName: str = Field(..., description='Наименование заказчика', example='ООО «Ромашка»')
    contractorInn: Optional[str] = Field(None, description='ИНН исполнителя', example='7722643959')
    contractorName: Optional[str] = Field(None, description='Наименование исполнителя', example='ООО «Ромашка»')
    clientInn: Optional[str] = Field(None, description='ИНН заказчика', example='7722643959')
    clientName: Optional[str] = Field(None, description='Наименование заказчика', example='ООО «Ромашка»')


class InitialContractResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    number: Optional[str] = Field(
        None,
        description='Номер договора, без начального символа № и т.п. Допускается null, в таком случае считаем, '
        'что договор без номера',
        example='Тест',
    )
    expirationDate: Optional[date] = Field(
        None, description='Дата окончания срока действия договора', example='2023-05-01'
    )
    amount: Optional[float] = Field(None, description='Стоимость услуг по договору в руб.', example=100)
    isAgentActingForPublisher: Optional[bool] = Field(
        None, description='Направление денежных средств в сторону заказчика', example=True
    )
    type: ContractType = Field(
        ...,
        description='Значение из справочника "Типы договоров"<p>Members:</p>'
        '<ul><li><i>ServiceAgreement</i> - Договор оказания услуг</li>'
        '<li><i>MediationContract</i> - Посреднический договор</li>'
        '<li><i>AdditionalAgreement</i> - Дополнительное соглашение к основному договору</li>'
        '<li><i>SelfPromotionContract</i> - Самореклама</li>'
        '<li><i>VirtualFinalContract</i> - Служебный договор, не доступен для создания ни через '
        'интерфейсе, ни через WebApi, не передается в ЕРИР</li>'
        '<li><i>EcidContract</i> - Договор, про который мы знаем только его ecid; не может быть '
        'родительским договором, дополнительным соглашением и т.д.; не регистрируется в ЕРИР</li></ul>',
    )
    subjectType: Optional[ContractSubjectType] = Field(
        None, description='Значение из справочника "Сведения о предмете договора"'
    )
    actionType: Optional[MediationActionType] = Field(
        None, description='Значение из справочника "Типы взаимодействия сторон посреднического договора"'
    )
    parentMainContractId: Optional[str] = Field(
        None, description='Id основного договора для доп.соглашения', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    contractorId: str = Field(
        ..., description='Id контрагента-исполнителя по изначальному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    clientId: str = Field(
        ..., description='Id контрагента-заказчика по изначальному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    finalContractId: str = Field(
        ..., description='Id или Cid доходного договора', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    id: str = Field(..., description='Id изначального договора в ОРД', example='CT0N4ufC76TEu1xBEIwJ3CaA')
    status: ContractStatus = Field(
        ...,
        description='Статус изначального договора в ОРД<p>Members:</p>'
        '<ul><li><i>Created</i> - Создан в БД (наша валидация пройдена). Пока не используется, '
        'сущность сразу переходит в статус [Ожидает регистрации].</li>'
        '<li><i>RegistrationRequired</i> - Ожидает регистрации в ЕРИР</li>'
        '<li><i>Registering</i> - Идет регистрация, быстрый контроль ЕРИР пройден, '
        'ждем уточненного ответа</li>'
        '<li><i>Active</i> - Активный</li>'
        '<li><i>RegistrationError</i> - Ошибка регистрации ЕРИР (любого этапа)</li>'
        '<li><i>Testing</i> - Тестирование - для тестирования массовой загрузки креативов на продовом контуре</li>'
        '<li><i>DeletionRequired</i> - Ожидает удаления в ЕРИР</li>'
        '<li><i>Deleting</i> - Идет удаление, быстрый контроль ЕРИР пройден, ждем уточненного ответа</li>'
        '<li><i>DeletionError</i> - Ошибка удаления в ЕРИР (любого этапа)</li>'
        '<li><i>Deleted</i> - Удален в ЕРИР</li></ul>',
    )
    # TODO: вернуть, когда МС починит возврат этих полей
    # contractorInn: str = Field(..., description='ИНН исполнителя', example='7722643959')
    # contractorName: str = Field(..., description='Наименование исполнителя', example='ООО «Ромашка»')
    # clientInn: str = Field(..., description='ИНН заказчика', example='7722643959')
    # clientName: str = Field(..., description='Наименование заказчика', example='ООО «Ромашка»')
    contractorInn: Optional[str] = Field(None, description='ИНН исполнителя', example='7722643959')
    contractorName: Optional[str] = Field(None, description='Наименование исполнителя', example='ООО «Ромашка»')
    clientInn: Optional[str] = Field(None, description='ИНН заказчика', example='7722643959')
    clientName: Optional[str] = Field(None, description='Наименование заказчика', example='ООО «Ромашка»')
    cid: Optional[str] = Field(
        None, description='Cid изначального договора', example='763acd99-687b-46cd-8f40-45eced77413c'
    )
    erirValidationError: Optional[ErirValidationError] = None
    date: date = Field(..., description='Дата заключения договора', example='2023-04-01')


class InvoiceInitialContractItem(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    initialContractId: str = Field(
        ..., description='Id или Cid изначального договора', example='CT7ae_PK9R0hCdAb-NfHH2fN'
    )
    amount: float = Field(
        ..., description='Стоимость услуг по изначальному договору в составе акта в руб.', example=1500
    )


class InvoiceResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    number: Optional[str] = Field(
        None, description='Номер акта. Допускается null, в таком случае считаем, что акт без номера', example='Тест'
    )
    contractorRole: InvoicePartyRole = Field(
        ...,
        description='Роль исполнителя в акте<p>Members:</p>'
        '<ul><li><i>Rr</i> - Рекламораспространитель</li>'
        '<li><i>Ors</i> - Оператор рекламной системы</li>'
        '<li><i>Rd</i> - Рекламодатель</li>'
        '<li><i>Ra</i> - Рекламное агентство</li></ul>',
        example='Ra',
    )
    clientRole: InvoicePartyRole = Field(
        ...,
        description='Роль заказчика в акте<p>Members:</p>'
        '<ul><li><i>Rr</i> - Рекламораспространитель</li>'
        '<li><i>Ors</i> - Оператор рекламной системы</li>'
        '<li><i>Rd</i> - Рекламодатель</li>'
        '<li><i>Ra</i> - Рекламное агентство</li></ul>',
        example='Rd',
    )
    amount: float = Field(..., description='Общая стоимость по акту в руб.', example=100)
    startDate: date = Field(..., description='Дата начала оказания услуг по акту', example='2022-12-01')
    endDate: date = Field(
        ..., description='Дата окончания оказания услуг по акту (включительно)', example='2022-12-31'
    )
    finalContractId: str = Field(
        ..., description='Id доходного договора в ОРД', example='CT3at_SU7y3ECdCb-AfHV3sA'
    )
    id: str = Field(..., description='Идентификатор акта', example='INUFNs1ibfg0erF1PNpTOAyg')
    status: InvoiceStatus = Field(
        ...,
        description='Статус акта в ОРД<p>Members:</p>'
        '<ul><li><i>Creating</i> - Идет загрузка в ОРД (технический статус)</li>'
        '<li><i>Created</i> - Черновик (загрузка в ОРД завершена), нужно послать в ЕРИР</li>'
        '<li><i>RegistrationRequired</i> - Ожидает регистрации в ЕРИР</li>'
        '<li><i>Transferring</i> - Идет передача в ЕРИР, после чего перадача шапки акта, '
        'разаллокации и статистики</li>'
        '<li><i>Registering</i> - Идет регистрация, удаленные креативы и статистика переданы, '
        'также передана остальная информация по акту, быстрый контроль ЕРИР пройден, через сутки '
        'ждем уточненного ответа</li>'
        '<li><i>Active</i> - Активный, зарегистрирован в ЕРИР</li>'
        '<li><i>RegistrationError</i> - Ошибка регистрации в ЕРИР (любого этапа)</li>'
        '<li><i>DeletionRequired</i> - Ожидает удаления в ЕРИР</li>'
        '<li><i>DeletionTransferring</i> - Идет передача в ЕРИР удаленных креативов и строк, '
        'после чего перадача шапки акта, разаллокации и статистики</li>'
        '<li><i>Deleting</i> - Идет передача креативов и статистики для удаления, либо быстрый '
        'контроль всего ЕРИР пройден, через сутки ждем уточненного ответа</li>'
        '<li><i>DeletionError</i> - Ошибка удаления в ЕРИР (любого этапа)</li>'
        '<li><i>Deleted</i> - Удален в ЕРИР</li></ul>',
    )
    erirValidationError: Optional[ErirValidationError] = None
    date: date = Field(..., description='Дата акта', example='2022-12-31')


class InvoiceStatisticsByPlatformsItem(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    erid: str = Field(..., description='Маркер креатива', example='Pb3MmBtzsrbL19RgOqsipS1ANueaCUzJSdpiY5g')
    platformUrl: Optional[str] = Field(None, description='URL площадки', example='https://example.ru')
    platformName: Optional[str] = Field(None, description='Наименование площадки', example='test')
    platformType: Optional[PlatformType] = Field(
        None, description='Значение из справочника "Типы площадок"', example='Site'
    )
    platformOwnedByAgency: Optional[bool] = Field(None, description='Принадлежит ли площадка агентству', example=False)
    type: Optional[CampaignType] = Field(None, description='Тип рекламной кампании', example='CPM')
    impsPlan: int = Field(..., description='Количество показов по акту', example=100)
    impsFact: int = Field(..., description='Количество показов фактическое', example=100)
    startDatePlan: date = Field(..., description='Дата начала показов по акту', example='2022-12-01')
    startDateFact: date = Field(..., description='Дата начала показов фактическая', example='2022-12-01')
    endDatePlan: date = Field(..., description='Дата окончания показов по акту', example='2022-12-31')
    endDateFact: date = Field(..., description='Дата окончания показов фактическая', example='2022-12-31')
    amount: float = Field(..., description='Стоимость услуг по показу креатива на данной площадке в руб.', example=100)
    price: float = Field(..., description='Стоимость единицы оказания услуг на данной площадке в руб.', example=10)
    initialContractId: str = Field(
        ..., description='Id или Cid изначального договора', example='CT7ae_PK9R0hCdAb-NfHH2fN'
    )


class InvoiceSummaryResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: str = Field(..., description='Id акта в ОРД', example='INUFNs1ibfg0erF1PNpTOAyg')
    status: InvoiceStatus = Field(
        ...,
        description='Статус акта в ОРД<p>Members:</p>'
        '<ul><li><i>Creating</i> - Идет загрузка в ОРД (технический статус)</li>'
        '<li><i>Created</i> - Черновик (загрузка в ОРД завершена), нужно послать в ЕРИР</li>'
        '<li><i>RegistrationRequired</i> - Ожидает регистрации в ЕРИР</li>'
        '<li><i>Transferring</i> - Идет передача в ЕРИР, после чего перадача шапки акта, '
        'разаллокации и статистики</li>'
        '<li><i>Registering</i> - Идет регистрация, удаленные креативы и статистика переданы, '
        'также передана остальная информация по акту, быстрый контроль ЕРИР пройден, '
        'через сутки ждем уточненного ответа</li>'
        '<li><i>Active</i> - Активный, зарегистрирован в ЕРИР</li>'
        '<li><i>RegistrationError</i> - Ошибка регистрации в ЕРИР (любого этапа)</li>'
        '<li><i>DeletionRequired</i> - Ожидает удаления в ЕРИР</li>'
        '<li><i>DeletionTransferring</i> - Идет передача в ЕРИР удаленных креативов и строк, после '
        'чего перадача шапки акта, разаллокации и статистики</li>'
        '<li><i>Deleting</i> - Идет передача креативов и статистики для удаления, либо быстрый '
        'контроль всего ЕРИР пройден, через сутки ждем уточненного ответа</li>'
        '<li><i>DeletionError</i>List[ - Ошибка удаления в ЕРИР (любого этапа)</li>'
        '<li><i>Deleted</i> - Удален в ЕРИР</li></ul>',
    )
    amount: float = Field(..., description='Общая стоимость по акту в руб.', example=100)
    initialContractsCount: int = Field(..., description='Кол-во изначальных договоров в акте', example=12)
    initialContractsAmount: float = Field(
        ..., description='Сумма стоимостей услуг по всем изначальным договорам в составе акта в руб.', example=1000
    )
    creativesCount: int = Field(..., description='Кол-во креативов в акте', example=50)
    platformsCount: int = Field(..., description='Кол-во уникальных площадок в акте', example=500)
    impsFactCount: int = Field(..., description='Общее число фактических показов', example=1500)
    impsPlanCount: int = Field(..., description='Общее число показов по акту', example=1400)
    impsAmount: float = Field(..., description='Общая стоимость показов по акту', example=2000)


class InvoicelessStatisticsByPlatforms(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    erid: str = Field(..., description='Маркер креатива', example='Pb3MmBtzsrbL19RgOqsipS1ANueaCUzJSdpiY5g')
    platformUrl: Optional[str] = Field(None, description='URL площадки', example='https://example.ru')
    platformName: Optional[str] = Field(None, description='Наименование площадки', example='test')
    platformType: Optional[PlatformType] = Field(
        None, description='Значение из справочника "Типы площадок"', example='Site'
    )
    platformOwnedByAgency: Optional[bool] = Field(None, description='Принадлежит ли площадка агентству', example=False)
    type: Optional[CampaignType] = Field(None, description='Тип рекламной кампании', example='CPM')
    impsPlan: int = Field(..., description='Количество показов по акту', example=100)
    impsFact: int = Field(..., description='Количество показов фактическое', example=100)
    startDatePlan: date = Field(..., description='Дата начала показов по акту', example='2022-12-01')
    startDateFact: date = Field(..., description='Дата начала показов фактическая', example='2022-12-01')
    endDatePlan: date = Field(..., description='Дата окончания показов по акту', example='2022-12-31')
    endDateFact: date = Field(..., description='Дата окончания показов фактическая', example='2022-12-31')
    amount: float = Field(..., description='Стоимость услуг по показу креатива на данной площадке в руб.', example=100)
    price: float = Field(..., description='Стоимость единицы оказания услуг на данной площадке в руб.', example=10)


class InvoicelessStatisticsResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: str = Field(..., description='Id акта в ОРД')
    status: InvoicelessPeriodStatus = Field(
        ...,
        description='Статус периода в ОРД<p>Members:</p>'
        '<ul><li><i>Creating</i> - Идет загрузка в ОРД (технический статус)</li>'
        '<li><i>RegistrationRequired</i> - Ожидает регистрации в ЕРИР</li>'
        '<li><i>Registering</i> - Идет регистрация, быстрый контроль ЕРИР пройден, ждем уточненного '
        'ответа, включая ответ по креативам и статистике</li>'
        '<li><i>Active</i> - Активный, зарегистрирован в ЕРИР</li>'
        '<li><i>RegistrationError</i> - Ошибка регистрации ЕРИР (любого этапа)</li></ul>',
    )
    erirValidationError: Optional[ErirValidationError] = None
    year: int = Field(..., description='Год периода')
    month: int = Field(..., description='Месяц периода')
    amount: float = Field(..., description='Общая стоимость по акту в руб.')
    creativesCount: int = Field(..., description='Кол-во креативов в акте')
    platformsCount: int = Field(..., description='Кол-во уникальных площадок в акте')
    impsFactCount: int = Field(..., description='Общее число фактических показов')
    impsPlanCount: int = Field(..., description='Общее число показов по акту')


class CreatedOuterContractResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    number: Optional[str] = Field(
        None,
        description='Номер договора, без начального символа № и т.п. Допускается null, в таком случае считаем, что договор без номера',
        example='Тест',
    )
    date: date = Field(..., description='Дата заключения договора', example='2023-04-01')
    expirationDate: Optional[date] = Field(
        None, description='Дата окончания срока действия договора', example='2023-05-01'
    )
    amount: Optional[float] = Field(None, description='Стоимость услуг по договору в руб.', example=100)
    isAgentActingForPublisher: Optional[bool] = Field(
        None, description='Направление денежных средств в сторону заказчика', example=True
    )
    type: ContractType = Field(
        ...,
        description='Значение из справочника "Типы договоров"<p>Members:</p><ul><li><i>ServiceAgreement</i> - Договор оказания услуг</li><li><i>MediationContract</i> - Посреднический договор</li><li><i>AdditionalAgreement</i> - Дополнительное соглашение к основному договору</li><li><i>SelfPromotionContract</i> - Самореклама</li><li><i>VirtualFinalContract</i> - Служебный договор, не доступен для создания ни через интерфейсе, ни через WebApi, не передается в ЕРИР</li><li><i>EcidContract</i> - Договор, про который мы знаем только его ecid; не может быть родительским договором, дополнительным соглашением и т.д.; не регистрируется в ЕРИР</li></ul>',
    )
    subjectType: Optional[ContractSubjectType] = Field(
        None, description='Значение из справочника "Сведения о предмете договора"'
    )
    actionType: Optional[MediationActionType] = Field(
        None, description='Значение из справочника "Типы взаимодействия сторон посреднического договора"'
    )
    parentMainContractId: Optional[str] = Field(
        None, description='Id основного договора для доп.соглашения', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    contractorId: str = Field(
        ..., description='Id контрагента-исполнителя по изначальному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    partnerId: Optional[str] = Field(None, description='Id партнера', example='CLhOO5UT6sIk-fIRu-QEsEuQ')
    isRegReport: bool = Field(
        ...,
        description='Признак того, что исполнитель по договору (Агентство, к которому относится договор) должен регистрировать креативы и предоставлять разаллокацию по ним в актах',
    )
    id: str = Field(..., description='Id договора в ОРД', example='CT0N4ufC76TEu1xBEIwJ3CaA')
    status: ContractStatus = Field(
        ...,
        description='Статус договора в ОРД<p>Members:</p><ul><li><i>Created</i> - Создан в БД (наша валидация пройдена). Пока не используется, сущность сразу переходит в статус [Ожидает регистрации].</li><li><i>RegistrationRequired</i> - Ожидает регистрации в ЕРИР</li><li><i>Registering</i> - Идет регистрация, быстрый контроль ЕРИР пройден, ждем уточненного ответа</li><li><i>Active</i> - Активный</li><li><i>RegistrationError</i> - Ошибка регистрации ЕРИР (любого этапа)</li><li><i>Testing</i> - Тестирование - для тестирования массовой загрузки креативов на продовом контуре</li><li><i>DeletionRequired</i> - Ожидает удаления в ЕРИР</li><li><i>Deleting</i> - Идет удаление, быстрый контроль ЕРИР пройден, ждем уточненного ответа</li><li><i>DeletionError</i> - Ошибка удаления в ЕРИР (любого этапа)</li><li><i>Deleted</i> - Удален в ЕРИР</li></ul>',
    )


class OuterContractResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: str = Field(..., description='Id договора в ОРД', example='CT0N4ufC76TEu1xBEIwJ3CaA')
    number: Optional[str] = Field(
        None,
        description='Номер договора, без начального символа № и т.п. Допускается null, в таком случае считаем, '
        'что договор без номера',
        example='Тест',
    )
    date: date = Field(..., description='Дата заключения договора', example='2023-04-01')
    expirationDate: Optional[date] = Field(
        None, description='Дата окончания срока действия договора', example='2023-05-01'
    )
    amount: Optional[float] = Field(None, description='Стоимость услуг по договору в руб.', example=100)
    isAgentActingForPublisher: Optional[bool] = Field(
        None, description='Направление денежных средств в сторону заказчика', example=True
    )
    type: ContractType = Field(
        ...,
        description='Значение из справочника "Типы договоров"<p>Members:</p>'
        '<ul><li><i>ServiceAgreement</i> - Договор оказания услуг</li>'
        '<li><i>MediationContract</i> - Посреднический договор</li>'
        '<li><i>AdditionalAgreement</i> - Дополнительное соглашение к основному договору</li>'
        '<li><i>SelfPromotionContract</i> - Самореклама</li>'
        '<li><i>VirtualFinalContract</i> - Служебный договор, не доступен для создания ни через '
        'интерфейсе, ни через WebApi, не передается в ЕРИР</li>'
        '<li><i>EcidContract</i> - Договор, про который мы знаем только его ecid; не может быть '
        'родительским договором, дополнительным соглашением и т.д.; не регистрируется в ЕРИР</li></ul>',
    )
    subjectType: Optional[ContractSubjectType] = Field(
        None, description='Значение из справочника "Сведения о предмете договора"'
    )
    actionType: Optional[MediationActionType] = Field(
        None, description='Значение из справочника "Типы взаимодействия сторон посреднического договора"'
    )
    parentMainContractId: Optional[str] = Field(
        None, description='Id основного договора для доп.соглашения', example='CT0N4ufC76TEu1xBEIwJ3CaA'
    )
    contractorId: str = Field(
        ..., description='Id контрагента-исполнителя по изначальному договору', example='CLhOO5UT6sIk-fIRu-QEsEuQ'
    )
    partnerId: str = Field(None, description='Id партнера', example='CLhOO5UT6sIk-fIRu-QEsEuQ')
    isRegReport: bool = Field(
        ...,
        description='Признак того, что исполнитель по договору (Агентство, к которому относится договор) должен '
        'регистрировать креативы и предоставлять разаллокацию по ним в актах',
    )
    status: ContractStatus = Field(
        ...,
        description='Статус договора в ОРД<p>Members:</p>'
        '<ul><li><i>Created</i> - Создан в БД (наша валидация пройдена). Пока не используется, сущность '
        'сразу переходит в статус [Ожидает регистрации].</li>'
        '<li><i>RegistrationRequired</i> - Ожидает регистрации в ЕРИР</li>'
        '<li><i>Registering</i> - Идет регистрация, быстрый контроль ЕРИР пройден, ждем уточненного '
        'ответа</li>'
        '<li><i>Active</i> - Активный</li>'
        '<li><i>RegistrationError</i> - Ошибка регистрации ЕРИР (любого этапа)</li>'
        '<li><i>Testing</i> - Тестирование - для тестирования массовой загрузки '
        'креативов на продовом контуре</li>'
        '<li><i>DeletionRequired</i> - Ожидает удаления в ЕРИР</li>'
        '<li><i>Deleting</i> - Идет удаление, быстрый контроль ЕРИР пройден, ждем уточненного ответа</li>'
        '<li><i>DeletionError</i> - Ошибка удаления в ЕРИР (любого этапа)</li>'
        '<li><i>Deleted</i> - Удален в ЕРИР</li></ul>',
    )
    cid: Optional[str] = Field(
        None, description='Cid расходного договора', example='763acd99-687b-46cd-8f40-45eced77413c'
    )
    erirValidationError: Optional[ErirValidationError] = None


class PartialClearInvoiceStatisticsItem(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True
    erid: str = Field(..., description='Маркер креатива', example='2SDnjegvUsB')
    platformUrl: str = Field(..., description='URL площадки', example='https://example.com')
    type: Optional[CampaignType] = Field(None, description='Тип рекламной кампании', example='CPM')
    startDatePlan: date = Field(..., description='Дата начала показов по акту', example='2024-05-22')
    startDateFact: date = Field(..., description='Дата начала показов фактическая', example='2024-05-22')
    endDatePlan: date = Field(..., description='Дата окончания показов по акту', example='2024-05-22')
    endDateFact: date = Field(..., description='Дата окончания показов фактическая', example='2024-05-22')
    initialContractId: str = Field(
        ..., description='Id или Cid изначального договора', example='CTRl8rP7sBCU6KfyeCWdYBcw'
    )

# PartialClearInvoiceRequest
class PartialClearInvoiceWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    initialContracts: Optional[List[str]] = Field(
        None,
        description='Список Id или Cid изначальных договоров из разаллокации для удаления',
        example=['CTRl8rP7sBCU6KfyeCWdYBcw', 'CTZOB4HKDab0yLLDvJ45OKUg'],
    )
    statisticsByPlatforms: Optional[List[PartialClearInvoiceStatisticsItem]] = Field(
        None, description='Список строк статистики для удаления'
    )


class PartialClearInvoiceInitialContractsRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    initialContracts: List[str] = Field(
        ...,
        description='Список Id или Cid изначальных договоров.',
        example=['CTRl8rP7sBCU6KfyeCWdYBcw', 'CTZOB4HKDab0yLLDvJ45OKUg'],
    )


class PartialClearInvoiceStatisticsRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    statistics: List[PartialClearInvoiceStatisticsItem] = Field(..., description='Строки статистики для удаления')


class PlatformResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    name: str = Field(..., description='Наименование площадки', example='Тестовая площадка')
    type: PlatformType = Field(
        ...,
        description='Тип площадки<p>Members:</p>'
        '<ul><li><i>Site</i> - Сайт</li>'
        '<li><i>Application</i> - Приложение</li>'
        '<li><i>InformationSystem</i> - Информационная система, не поддерживается '
        'начиная с ЕРИР v.5</li></ul>',
    )
    url: Optional[str] = Field(None, description='Url площадки', example='https://example.com')
    isOwner: bool = Field(..., description='Признак принадлежности агентству')
    id: str = Field(..., description='Идентификатор площадки', example='PLCqwqXBhLMk6eTsIQoUT48A')

# SupplementInvoiceRequest
class SupplementInvoiceWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    invoiceId: Optional[str] = Field(None, description='Id акта в ОРД')
    initialContractsData: Optional[List[InvoiceInitialContractItem]] = Field(
        None, description='Данные по изначальным договорам для добавления к акту (массив)'
    )
    statisticsByPlatforms: Optional[List[InvoiceStatisticsByPlatformsItem]] = Field(
        None, description='Статистика по площадкам для добавления к акту (массив)'
    )


class TargetAudienceParam(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    type: TargetAudienceParamType = Field(
        ...,
        description='Тип параметра: регион, пол, возраст<p>Members:</p>'
        '<ul><li><i>Geo</i> - Код региона</li>'
        '<li><i>Sex</i> - Пол</li>'
        '<li><i>Age</i> - Возраст</li></ul>',
    )
    values: List[str] = Field(
        ...,
        description='Коллекция значений\n'
        '<ul><li>Для типа "geo":\r\n<ul><li>Максимальная длина: 2</li>'
        '<li>Длина строки 2, может содержать цифры 0-9</li>'
        '<li>В элементах массива передаются коды регионов. Если массив пустой, то геотаргетинг направлен '
        'на всю Россию</li></ul></li>'
        '<li>Для типа "sex":\n<ul>'
        '<li>male - мужчины</li>'
        '<li>female - женщины</li></ul>\r\n'
        'Если таргетинг на аудиторию не зависящую от пола, то параметр не передается.\r\n</li>'
        '<li>Для типа "age":\n'
        '<ul><li>"<минимальный возраст>:<максимальный возраст>".</li>'
        '<li>Например, "25:45" - означает, что реклама таргетируется на аудиторию от 25 до 45 лет.</li>'
        '</ul>\r\nЕсли таргетинг на любой возраст, то параметр не передается\r\n</li></ul>',
    )


class ClientResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    createMode: Optional[ClientRelationshipType] = Field(None, description='Тип отношения заказчика к агентству')
    legalForm: LegalForm = Field(
        ...,
        description='Юридическая форма заказчика<p>Members:</p>'
        '<ul><li><i>JuridicalPerson</i> - Юрлицо РФ</li>'
        '<li><i>IndividualEntrepreneur</i> - Индивидуальный предприниматель РФ</li>'
        '<li><i>PhysicalPerson</i> - Физлицо РФ</li>'
        '<li><i>InternationalJuridicalPerson</i> - Иностранное юрлицо</li>'
        '<li><i>InternationalPhysicalPerson</i> - Иностранное физлицо</li></ul>',
    )
    inn: str = Field(
        ...,
        description='Для РФ-контрагентов - ИНН. Для иностранных физ.и юр.лиц - номер налогоплательщика либо его '
        'аналог в стране регистрации',
        example='1234567890',
    )
    name: str = Field(..., description='Наименование контрагента', example='Наименование контрагента')
    mobilePhone: Optional[str] = Field(None, description='Номер мобильного телефона', example='79999999999')
    epayNumber: Optional[str] = Field(None, description='Номер электронного средства платежа')
    regNumber: Optional[str] = Field(None, description='Регистрационный номер либо его аналог')
    oksmNumber: Optional[str] = Field(None, description='Код страны регистрации юр. лица в соответствии с ОКСМ')
    id: str = Field(..., description='Id контрагента в ОРД', example='CLfFpx6Ee4qkawO6JwEDJqFQ')
    status: CounterpartyStatus = Field(
        ...,
        description='Статус контрагента в ОРД<p>Members:</p>'
        '<ul><li><i>Created</i> - Создан в БД (наша валидация пройдена). Пока не используется, сущность '
        'сразу переходит в статус [Ожидает регистрации].</li>'
        '<li><i>RegistrationRequired</i> - Ожидает регистрации в ЕРИР</li>'
        '<li><i>Registering</i> - Идет регистрация, быстрый контроль ЕРИР пройден, '
        'ждем уточненного ответа</li>'
        '<li><i>Active</i> - Активный (оба этапа ЕРИР-регистрации завершены успешно)</li>'
        '<li><i>RegistrationError</i> - Ошибка регистрации ЕРИР (любого этапа)</li>'
        '<li><i>Blocked</i> - Заблокирован (применимо только к TopLevelAgency)</li></ul>',
    )
    erirValidationError: Optional[ErirValidationError] = None


class CreateCreativeRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    nativeCustomerId: Optional[str] = Field(
        None,
        description='Id креатива в системе клиента\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
    )
    creativeGroupId: Optional[str] = Field(
        None,
        description='Id группы (брони) креативов\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
        example='CG3oAF-jsLEkGx83pCs9-FPQ',
    )
    creativeGroupName: Optional[str] = Field(
        None,
        description='Имя группы (брони) креативов.\r\n<p style="color: blue">Поле условно-обязательно '
        'для заполнения. Обязательно при создании новой группы (брони) креативов</p>',
        example='ТестоваяГруппа',
    )
    creativeGroupStartDate: Optional[date] = Field(
        None,
        description='Дата начала рекламной компании\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
        example='2023-01-01',
    )
    creativeGroupEndDate: Optional[date] = Field(
        None,
        description='Дата окончания рекламной компании\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
        example='2023-30-01',
    )
    finalContractId: Optional[str] = Field(
        None,
        description='Id доходного договора в ОРД\r\n<p style="color: blue">Поле условно-обязательно '
        'для заполнения. Для креатива саморекламы не должно заполняться</p>',
        example='CT6WFbMXPGcE2lx5Ffm-npAg',
    )
    initialContractId: Optional[str] = Field(
        None,
        description='Id или Cid изначального договора. Если креатив создается на доходный договор, то нужно '
        'указать InitialContractId = FinalContractId\r\n<p style="color: blue">Поле условно-обязательно '
        'для заполнения. Для креатива саморекламы не должно заполняться</p>',
        example='AAADgMygKIOkyGuPfl83W1ow',
    )
    isSelfPromotion: bool = Field(
        ..., description='Является креативом саморекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    type: CampaignType = Field(
        ...,
        description='Тип рекламной кампании\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
        '<p>Members:</p>'
        '<ul><li><i>CPM</i> - Cost Per Millennium, оплата за тысячу показов</li>'
        '<li><i>CPC</i> - Cost Per Click, оплата за клик баннера</li>'
        '<li><i>CPA</i> - Cost Per Action, оплата за совершенное целевое действие</li>'
        '<li><i>Other</i> - Иное</li></ul>',
    )
    form: CreativeForm = Field(
        ...,
        description='Форма распространения рекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
        '<p>Members:</p>'
        '<ul><li><i>Banner</i> - Баннер</li>'
        '<li><i>Text</i> - Текстовый блок</li>'
        '<li><i>TextGraphic</i> - Текстово-графический блок</li>'
        '<li><i>Video</i> - Видеоролик</li>'
        '<li><i>Audio</i> - Аудиозапись</li>'
        '<li><i>AudioBroadcast</i> - Аудиотрансляции в прямом эфире</li>'
        '<li><i>VideoBroadcast</i> - Видеотрансляции в прямом эфире</li>'
        '<li><i>Other</i> - Иное - не поддерживается начиная с ЕРИР v.5</li>'
        '<li><i>TextVideoBlock</i> - Текстовый блок с видео</li>'
        '<li><i>TextAudioBlock</i> - Текстовый блок с аудио</li>'
        '<li><i>TextAudioVideoBlock</i> - Текстовый блок с аудио и видео</li>'
        '<li><i>TextGraphicVideoBlock</i> - Текстово-графический блок с видео</li>'
        '<li><i>TextGraphicAudioBlock</i> - Текстово-графический блок с аудио</li>'
        '<li><i>TextGraphicAudioVideoBlock</i> - Текстово-графический блок с аудио и видео</li>'
        '<li><i>BannerHtml5</i> - </li></ul>',
    )
    advertiserUrls: Optional[List[str]] = Field(
        None,
        description='Целевые ссылки (массив)\n\r\nПроверка URL:\r\n'
        '<ul><li>Проверить протокол http, https, ftp, sftp</li>'
        '<li>Проверить хост: в нем не должно содержаться punycode или urlencode</li></ul>'
        '<p style="color: lightblue">Поле не обязательно для заполнения</p>',
        example=['http://test.ru'],
    )
    description: str = Field(
        ...,
        description='Общее описание объекта рекламирования\r\n'
        '<ul><li>Минимальная длина: 1</li>'
        '<li>Максимальная длина: 1000</li>'
        '<li>Длина строки от 1 до 1000, может содержать цифры и буквы, а также все спец символы</li>'
        '<li>В начале и в конце не должно быть пробела и переноса на другую строку</li></ul>'
        '<p style="color: blue">Поле обязательно для заполнения</p>',
        example='Описание креатива 4H67RLFG',
    )
    targetAudienceParams: Optional[List[TargetAudienceParam]] = Field(
        None,
        description='Параметры целевой аудитории рекламы\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
    )
    isNative: bool = Field(
        ..., description='Признак нативной рекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    isSocial: bool = Field(
        ..., description='Признак социальной рекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    isSocialQuota: bool = Field(
        ..., description='Признак социальной рекламы по квоте\r\n           <p style=\"color: lightblue\">Поле не обязательно для заполнения. Если не заполнено, устанавливается значение `false`</p>'
    )
    kktuCodes: Optional[List[str]] = Field(
        None,
        description="Список кодов ККТУ. Возможные значения кодов ККТУ можно получить через метод `/webapi/v3/dictionaries/kktu`.\r\nДопускаются только коды 3 уровня - \"X.X.X\".\r\nВ настоящий момент список не может содержать более одного значения. Указание нескольких значений станет доступно после введения функционала кобрендинга\r\n<p style=\"color: lightblue\">Поле не обязательно для заполнения</p>",
        example = '["30.1.2", "12.2.3"]'
    )
    mediaData: Optional[List[CreateCreativeMediaDataItem]] = Field(
        None,
        description='Медиаданные креатива (массив)\n\r\n'
        'Должен быть добавлен хотя бы один элемент при значениях поля form:\r\n'
        '<ul><li>TextGraphic</li>'
        '<li>TextVideoBlock</li>'
        '<li>TextAudioBlock</li>'
        '<li>TextAudioVideoBlock</li>'
        '<li>TextGraphicVideoBlock</li>'
        '<li>TextGraphicAudioBlock</li>'
        '<li>TextGraphicAudioVideoBlock</li>'
        '<li>Banner</li>'
        '<li>BannerHtml5</li>'
        '<li>Video</li>'
        '<li>Audio</li>'
        '<li>AudioBroadcast</li>'
        '<li>VideoBroadcast</li></ul>'
        '<p style="color: blue">Поле условно-обязательно для заполнения</p>',
    )
    textData: Optional[List[CreateCreativeTextDataItem]] = Field(
        None,
        description='Текстовые медиаданные креатива (массив)\n\r\nДолжен быть добавлен хотя бы один элемент '
        'при значениях поля form:\r\n'
        '<ul><li>Text</li>'
        '<li>TextGraphic</li>'
        '<li>TextVideoBlock</li>'
        '<li>TextAudioBlock</li>'
        '<li>TextAudioVideoBlock</li>'
        '<li>TextGraphicVideoBlock</li>'
        '<li>TextGraphicAudioBlock</li>'
        '<li>TextGraphicAudioVideoBlock</li></ul>'
        '<p style="color: blue">Поле условно-обязательно для заполнения</p>',
    )


class CreateInvoiceRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    number: Optional[str] = Field(
        None, description='Номер акта. Допускается null, в таком случае считаем, что акт без номера', example='Тест'
    )
    contractorRole: InvoicePartyRole = Field(
        ...,
        description='Роль исполнителя в акте<p>Members:</p>'
        '<ul><li><i>Rr</i> - Рекламораспространитель</li>'
        '<li><i>Ors</i> - Оператор рекламной системы</li>'
        '<li><i>Rd</i> - Рекламодатель</li>'
        '<li><i>Ra</i> - Рекламное агентство</li></ul>',
        example='Ra',
    )
    clientRole: InvoicePartyRole = Field(
        ...,
        description='Роль заказчика в акте<p>Members:</p>'
        '<ul><li><i>Rr</i> - Рекламораспространитель</li>'
        '<li><i>Ors</i> - Оператор рекламной системы</li>'
        '<li><i>Rd</i> - Рекламодатель</li>'
        '<li><i>Ra</i> - Рекламное агентство</li></ul>',
        example='Rd',
    )
    amount: float = Field(..., description='Общая стоимость по акту в руб.', example=100)
    startDate: date = Field(..., description='Дата начала оказания услуг по акту', example='2022-12-01')
    endDate: date = Field(
        ..., description='Дата окончания оказания услуг по акту (включительно)', example='2022-12-31'
    )
    finalContractId: str = Field(
        ..., description='Id доходного договора в ОРД', example='CT3at_SU7y3ECdCb-AfHV3sA'
    )
    initialContractsData: Optional[List[InvoiceInitialContractItem]] = Field(
        None, description='Данные по изначальным договорам (массив)'
    )
    statisticsByPlatforms: Optional[List[InvoiceStatisticsByPlatformsItem]] = Field(
        None, description='Статистика по площадкам (массив)'
    )
    date: date = Field(..., description='Дата акта', example='2022-12-31')


class CreateInvoicelessStatisticsRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    statistics: Optional[List[InvoicelessStatisticsByPlatforms]] = Field(
        None, description='Статистика по площадкам (массив)'
    )


class CreativeGroupResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    creativeGroupId: str = Field(
        ..., description='Id группы креативов\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    finalContractId: Optional[str] = Field(
        None,
        description='Id конечного договора, к которому привязана группа креативов\r\n'
        '<p style="color: blue">Поле условно-обязательно для заполнения. '
        'Для креатива саморекламы не должно заполняться</p>',
    )
    initialContractId: Optional[str] = Field(
        None,
        description='Id или Cid изначального договора, к которому относится группа креативов\r\n'
        '<p style="color: blue">Поле условно-обязательно для заполнения. '
        'Для креатива саморекламы не должно заполняться</p>',
    )
    isSelfPromotion: bool = Field(
        ...,
        description='Креативы относятся к саморекламе\r\n<p style="color: blue">Поле обязательно для заполнения</p>',
    )
    creativeGroupName: str = Field(
        ..., description='Наименование\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    startDate: Optional[date] = Field(
        None, description='Дата начала рекламной компании\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    endDate: Optional[date] = Field(
        None,
        description='Дата окончания рекламной компании\r\n<p style="color: blue">Поле обязательно для заполнения</p>',
    )
    type: CampaignType = Field(
        ...,
        description='Тип рекламной кампании\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
        '<p>Members:</p>'
        '<ul><li><i>CPM</i> - Cost Per Millennium, оплата за тысячу показов</li>'
        '<li><i>CPC</i> - Cost Per Click, оплата за клик баннера</li>'
        '<li><i>CPA</i> - Cost Per Action, оплата за совершенное целевое действие</li>'
        '<li><i>Other</i> - Иное</li></ul>',
    )
    form: CreativeForm = Field(
        ...,
        description='Форма распространения рекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
        '<p>Members:</p>'
        '<ul><li><i>Banner</i> - Баннер</li>'
        '<li><i>Text</i> - Текстовый блок</li>'
        '<li><i>TextGraphic</i> - Текстово-графический блок</li>'
        '<li><i>Video</i> - Видеоролик</li>'
        '<li><i>Audio</i> - Аудиозапись</li>'
        '<li><i>AudioBroadcast</i> - Аудиотрансляции в прямом эфире</li>'
        '<li><i>VideoBroadcast</i> - Видеотрансляции в прямом эфире</li>'
        '<li><i>Other</i> - Иное - не поддерживается начиная с ЕРИР v.5</li>'
        '<li><i>TextVideoBlock</i> - Текстовый блок с видео</li>'
        '<li><i>TextAudioBlock</i> - Текстовый блок с аудио</li>'
        '<li><i>TextAudioVideoBlock</i> - Текстовый блок с аудио и видео</li>'
        '<li><i>TextGraphicVideoBlock</i> - Текстово-графический блок с видео</li>'
        '<li><i>TextGraphicAudioBlock</i> - Текстово-графический блок с аудио</li>'
        '<li><i>TextGraphicAudioVideoBlock</i> - Текстово-графический блок с аудио и видео</li>'
        '<li><i>BannerHtml5</i> - </li></ul>',
    )
    isSocial: bool = Field(
        ..., description='Признак социальной рекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    isNative: bool = Field(
        ..., description='Признак нативной рекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    isSocialQuota: bool = Field(
        ..., description='Признак социальной рекламы по квоте\r\n           <p style=\"color: lightblue\">Поле не обязательно для заполнения. Если не заполнено, устанавливается значение `false`</p>'
    )
    kktuCodes: Optional[List[str]] = Field(
        None,
        description="Список кодов ККТУ\r\n<p style=\"color: lightblue\">Поле не обязательно для заполнения</p>",
        example = '["30.1.2", "12.2.3"]'
    )
    targetAudienceParams: Optional[List[TargetAudienceParam]] = Field(
        None, description='Параметры целевой аудитории\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    description: str = Field(
        ...,
        description='Общее описание объекта рекламирования\r\n'
        '<ul><li>Минимальная длина: 1</li>'
        '<li>Максимальная длина: 1000</li>'
        '<li>Длина строки от 1 до 1000, может содержать цифры и буквы, а также все спец символы</li>'
        '<li>В начале и в конце не должно быть пробела и переноса на другую строку</li></ul>'
        '<p style="color: blue">Поле обязательно для заполнения</p>',
    )


class CreativeBaseStatusResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    status: CreativeStatus = Field(
        ...,
        description='Статус рекламного элемента<p>Members:</p><ul><li><i>Creating</i> - Идет загрузка в ОРД (элемент фида создан, но медиа-данные еще не загружены)</li><li><i>Created</i> - Создан в БД (наша валидация пройдена). Пока не используется, сущность сразу переходит в статус [Ожидает регистрации].</li><li><i>RegistrationRequired</i> - Ожидает регистрации в ЕРИР</li><li><i>Registering</i> - Идет регистрация, быстрый контроль ЕРИР пройден, ждем уточненного ответа</li><li><i>Active</i> - Активный</li><li><i>RegistrationError</i> - Ошибка регистрации ЕРИР (любого этапа)</li><li><i>DeletionRequired</i> - Ожидает удаления в ЕРИР</li><li><i>Deleting</i> - Идет удаление, быстрый контроль ЕРИР пройден, ждем уточненного ответа</li><li><i>DeletionError</i> - Ошибка удаления в ЕРИР (любого этапа)</li><li><i>Deleted</i> - Удален в ЕРИР</li></ul>',
    )
    erid: str = Field(..., description='Маркер рекламного элемента')


class CreativeResponse(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: str = Field(..., description='Id креатива в ОРД')
    erid: str = Field(
        ...,
        description='Маркер креатива для добавления в кликовые ссылки. Формируется '
        'в момент регистрации креатива в ЕРИР, в дальнейшем передаётся '
        'Агентствам',
    )
    status: CreativeStatus = Field(
        ...,
        description='Статус креатива<p>Members:</p>'
        '<ul><li><i>Creating</i> - Идет загрузка в ОРД (элемент фида создан, но медиа-данные '
        'еще не загружены)</li>'
        '<li><i>Created</i> - Создан в БД (наша валидация пройдена). Пока не используется, '
        'сущность сразу переходит в статус [Ожидает регистрации].</li>'
        '<li><i>RegistrationRequired</i> - Ожидает регистрации в ЕРИР</li>'
        '<li><i>Registering</i> - Идет регистрация, быстрый контроль ЕРИР пройден, '
        'ждем уточненного ответа</li>'
        '<li><i>Active</i> - Активный</li>'
        '<li><i>RegistrationError</i> - Ошибка регистрации ЕРИР (любого этапа)</li>'
        '<li><i>DeletionRequired</i> - Ожидает удаления в ЕРИР</li>'
        '<li><i>Deleting</i> - Идет удаление, быстрый контроль ЕРИР пройден, ждем уточненного ответа</li>'
        '<li><i>DeletionError</i> - Ошибка удаления в ЕРИР (любого этапа)</li>'
        '<li><i>Deleted</i> - Удален в ЕРИР</li></ul>',
    )
    nativeCustomerId: Optional[str] = Field(
        None,
        description='Id креатива в системе клиента\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
    )
    creativeGroupId: Optional[str] = Field(
        None,
        description='Id группы (брони) креативов\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
        example='CG3oAF-jsLEkGx83pCs9-FPQ',
    )
    creativeGroupName: Optional[str] = Field(
        None,
        description='Имя группы (брони) креативов.\r\n<p style="color: blue">Поле условно-обязательно '
        'для заполнения. Обязательно при создании новой группы (брони) креативов</p>',
        example='ТестоваяГруппа',
    )
    creativeGroupStartDate: Optional[date] = Field(
        None,
        description='Дата начала рекламной компании\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
        example='2023-01-01',
    )
    creativeGroupEndDate: Optional[date] = Field(
        None,
        description='Дата окончания рекламной компании\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
        example='2023-30-01',
    )
    finalContractId: Optional[str] = Field(
        None,
        description='Id доходного договора в ОРД\r\n<p style="color: blue">Поле условно-обязательно для заполнения. '
        'Для креатива саморекламы не должно заполняться</p>',
        example='CT6WFbMXPGcE2lx5Ffm-npAg',
    )
    initialContractId: Optional[str] = Field(
        None,
        description='Id или Cid изначального договора. Если креатив создается на доходный договор, то нужно указать '
        'InitialContractId = FinalContractId\r\n<p style="color: blue">Поле условно-обязательно '
        'для заполнения. Для креатива саморекламы не должно заполняться</p>',
        example='AAADgMygKIOkyGuPfl83W1ow',
    )
    isSelfPromotion: bool = Field(
        ..., description='Является креативом саморекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    type: CampaignType = Field(
        ...,
        description='Тип рекламной кампании\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
        '<p>Members:</p>'
        '<ul><li><i>CPM</i> - Cost Per Millennium, оплата за тысячу показов</li>'
        '<li><i>CPC</i> - Cost Per Click, оплата за клик баннера</li>'
        '<li><i>CPA</i> - Cost Per Action, оплата за совершенное целевое действие</li>'
        '<li><i>Other</i> - Иное</li></ul>',
    )
    form: CreativeForm = Field(
        ...,
        description='Форма распространения рекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
        '<p>Members:</p>'
        '<ul><li><i>Banner</i> - Баннер</li>'
        '<li><i>Text</i> - Текстовый блок</li>'
        '<li><i>TextGraphic</i> - Текстово-графический блок</li>'
        '<li><i>Video</i> - Видеоролик</li>'
        '<li><i>Audio</i> - Аудиозапись</li>'
        '<li><i>AudioBroadcast</i> - Аудиотрансляции в прямом эфире</li>'
        '<li><i>VideoBroadcast</i> - Видеотрансляции в прямом эфире</li>'
        '<li><i>Other</i> - Иное - не поддерживается начиная с ЕРИР v.5</li>'
        '<li><i>TextVideoBlock</i> - Текстовый блок с видео</li>'
        '<li><i>TextAudioBlock</i> - Текстовый блок с аудио</li>'
        '<li><i>TextAudioVideoBlock</i> - Текстовый блок с аудио и видео</li>'
        '<li><i>TextGraphicVideoBlock</i> - Текстово-графический блок с видео</li>'
        '<li><i>TextGraphicAudioBlock</i> - Текстово-графический блок с аудио</li>'
        '<li><i>TextGraphicAudioVideoBlock</i> - Текстово-графический блок с аудио и видео</li>'
        '<li><i>BannerHtml5</i> - </li></ul>',
    )
    advertiserUrls: Optional[List[str]] = Field(
        None,
        description='Целевые ссылки (массив)\n\r\nПроверка URL:\r\n'
        '<ul><li>Проверить протокол http, https, ftp, sftp</li>'
        '<li>Проверить хост: в нем не должно содержаться punycode или urlencode</li></ul>'
        '<p style="color: lightblue">Поле не обязательно для заполнения</p>',
        example=['http://test.ru'],
    )
    advertiserUrl: Optional[str] = Field(
        None,
        description='Целевая ссылка (не использовать, присутствует для обратной совместимости API)',
        example='http://test.ru',
    )
    description: str = Field(
        ...,
        description='Общее описание объекта рекламирования\r\n'
        '<ul><li>Минимальная длина: 1</li>'
        '<li>Максимальная длина: 1000</li>'
        '<li>Длина строки от 1 до 1000, может содержать цифры и буквы, а также все спец символы</li>'
        '<li>В начале и в конце не должно быть пробела и переноса на другую строку</li></ul>'
        '<p style="color: blue">Поле обязательно для заполнения</p>',
        example='Описание креатива 4H67RLFG',
    )
    targetAudienceParams: Optional[List[TargetAudienceParam]] = Field(
        None,
        description='Параметры целевой аудитории рекламы\r\n<p style="color: lightblue">Поле не обязательно '
        'для заполнения</p>',
    )
    isNative: bool = Field(
        ..., description='Признак нативной рекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    isSocial: bool = Field(
        ..., description='Признак социальной рекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    isSocialQuota: bool = Field(
        ..., description='Признак социальной рекламы по квоте\r\n           <p style=\"color: lightblue\">Поле не обязательно для заполнения. Если не заполнено, устанавливается значение `false`</p>'
    )
    kktuCodes: List[str] = Field(
        ...,
        description="Список кодов ККТУ\r\n<p style=\"color: lightblue\">Поле не обязательно для заполнения</p>",
        example = '["30.1.2", "12.2.3"]'
    )
    mediaData: List[CreativeMediaDataItem] = Field(
        ...,
        description='Медиаданные креатива (массив)\n\r\n'
        'Должен быть добавлен хотя бы один элемент при значениях поля form:\r\n'
        '<ul><li>TextGraphic</li>'
        '<li>TextVideoBlock</li>'
        '<li>TextAudioBlock</li>'
        '<li>TextAudioVideoBlock</li>'
        '<li>TextGraphicVideoBlock</li>'
        '<li>TextGraphicAudioBlock</li>'
        '<li>TextGraphicAudioVideoBlock</li>'
        '<li>Banner</li>'
        '<li>BannerHtml5</li>'
        '<li>Video</li>'
        '<li>Audio</li>'
        '<li>AudioBroadcast</li>'
        '<li>VideoBroadcast</li></ul>'
        '<p style="color: blue">Поле условно-обязательно для заполнения</p>',
    )
    textData: List[CreativeTextDataItemWebApiDto] = Field(
        ...,
        description='Текстовые медиаданные креатива (массив)\n\r\n'
        'Должен быть добавлен хотя бы один элемент при значениях поля form:\r\n'
        '<ul><li>Text</li>'
        '<li>TextGraphic</li>'
        '<li>TextVideoBlock</li>'
        '<li>TextAudioBlock</li>'
        '<li>TextAudioVideoBlock</li>'
        '<li>TextGraphicVideoBlock</li>'
        '<li>TextGraphicAudioBlock</li>'
        '<li>TextGraphicAudioVideoBlock</li></ul>'
        '<p style="color: blue">Поле условно-обязательно для заполнения</p>',
    )
    erirValidationError: Optional[ErirValidationError] = None

# EditInvoiceStatisticsRequest
class EditInvoiceStatisticsWebApiDto(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    initialContractsData: List[InvoiceInitialContractItem] = Field(
        ..., description='Данные по изначальным договорам (массив)'
    )
    statisticsByPlatforms: Optional[List[InvoiceStatisticsByPlatformsItem]] = Field(
        None, description='Статистика по площадкам (массив)'
    )


class SimpleEditCreativeRequest(BaseModel):
    class Config:
        extra = Extra.forbid
        alias_generator = capitalize
        allow_population_by_field_name = True

    id: Optional[str] = Field(
        None,
        description='Id креатива\r\n<p style="color: blue">Поле условно-обязательно для заполнения. Не должно '
        'заполняться одновременно с полями `NativeCustomerId`, `Erid`</p>',
        example='CR5pxRa__aRkSgUqt0JeNkoA',
    )
    nativeCustomerId: Optional[str] = Field(
        None,
        description='Id креатива в системе клиента\r\n<p style="color: blue">Поле условно-обязательно для заполнения. '
        'Не должно заполняться одновременно с полями `Id`, `Erid`</p>',
    )
    erid: Optional[str] = Field(
        None,
        description='Erid креатива\r\n<p style="color: blue">Поле условно-обязательно для заполнения. '
        'Не должно заполняться одновременно с полями `Id`, `NativeCustomerId`</p>',
        example='2SDnjcX1BkW',
    )
    startDate: Optional[date] = Field(
        None, description='Дата начала рекламной компании\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    endDate: Optional[date] = Field(
        None,
        description='Дата окончания рекламной компании\r\n<p style="color: blue">Поле обязательно для заполнения</p>',
    )
    finalContractId: Optional[str] = Field(
        None,
        description='Id доходного договора в ОРД\r\n<p style="color: blue">Поле условно-обязательно для заполнения. '
        'Для креатива саморекламы не должно заполняться</p>',
        example='CTRl8rP7sBCU6KfyeCWdYBcw',
    )
    initialContractId: Optional[str] = Field(
        None,
        description='Id или Cid изначального договора. Если креатив создается на доходный договор, то нужно указать'
        ' InitialContractId = FinalContractId.\r\n<p style="color: blue">Поле условно-обязательно '
        'для заполнения. Для креатива саморекламы не должно заполняться</p>',
        example='CTRl8rP7sBCU6KfyeCWdYBcw',
    )
    isSelfPromotion: bool = Field(
        ...,
        description='Креативы относятся к саморекламе\r\n<p style="color: blue">Поле обязательно для заполнения</p>',
    )
    type: CampaignType = Field(
        ...,
        description='Тип рекламной кампании\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
        '<p>Members:</p>'
        '<ul><li><i>CPM</i> - Cost Per Millennium, оплата за тысячу показов</li>'
        '<li><i>CPC</i> - Cost Per Click, оплата за клик баннера</li>'
        '<li><i>CPA</i> - Cost Per Action, оплата за совершенное целевое действие</li>'
        '<li><i>Other</i> - Иное</li></ul>',
    )
    form: CreativeForm = Field(
        ...,
        description='Форма распространения рекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
        '<p>Members:</p>'
        '<ul><li><i>Banner</i> - Баннер</li>'
        '<li><i>Text</i> - Текстовый блок</li>'
        '<li><i>TextGraphic</i> - Текстово-графический блок</li>'
        '<li><i>Video</i> - Видеоролик</li>'
        '<li><i>Audio</i> - Аудиозапись</li>'
        '<li><i>AudioBroadcast</i> - Аудиотрансляции в прямом эфире</li>'
        '<li><i>VideoBroadcast</i> - Видеотрансляции в прямом эфире</li>'
        '<li><i>Other</i> - Иное - не поддерживается начиная с ЕРИР v.5</li>'
        '<li><i>TextVideoBlock</i> - Текстовый блок с видео</li>'
        '<li><i>TextAudioBlock</i> - Текстовый блок с аудио</li>'
        '<li><i>TextAudioVideoBlock</i> - Текстовый блок с аудио и видео</li>'
        '<li><i>TextGraphicVideoBlock</i> - Текстово-графический блок с видео</li>'
        '<li><i>TextGraphicAudioBlock</i> - Текстово-графический блок с аудио</li>'
        '<li><i>TextGraphicAudioVideoBlock</i> - Текстово-графический блок с аудио и видео</li>'
        '<li><i>BannerHtml5</i> - </li></ul>',
    )
    advertiserUrls: Optional[List[str]] = Field(
        None,
        description='Целевые ссылки (массив)\r\nПроверка URL:\r\n'
        '<ul><li>Проверить протокол http, https, ftp, sftp</li>'
        '<li>Проверить хост: в нем не должно содержаться punycode или urlencode</li></ul>'
        '<p style="color: lightblue">Поле не обязательно для заполнения</p>',
        example=['http://test1.ru', 'http://test2.ru'],
    )
    description: str = Field(
        ...,
        description='Общее описание объекта рекламирования\r\n'
        '<ul><li>Минимальная длина: 1</li>'
        '<li>Максимальная длина: 1000</li>'
        '<li>Длина строки от 1 до 1000, может содержать цифры и буквы, а также все спец символы</li>'
        '<li>В начале и в конце не должно быть пробела и переноса на другую строку</li></ul>'
        '<p style="color: blue">Поле обязательно для заполнения</p>',
        example='Описание',
    )
    targetAudienceParams: Optional[List[TargetAudienceParam]] = Field(
        None,
        description='Параметры целевой аудитории\r\n<p style="color: lightblue">Поле не обязательно для заполнения</p>',
    )
    isNative: Optional[bool] = Field(
        ..., description='Признак нативной рекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    isSocial: Optional[bool] = Field(
        ..., description='Признак социальной рекламы\r\n<p style="color: blue">Поле обязательно для заполнения</p>'
    )
    isSocialQuota: bool = Field(
        ..., description='Признак социальной рекламы по квоте\r\n           <p style=\"color: lightblue\">Поле не обязательно для заполнения. Если не заполнено, устанавливается значение `false`</p>'
    )
    overwriteExistingCreativeMedia: bool = Field(
        ...,
        description='Перезаписать все предыдущие медиаданные креатива (файловые и текстовые). Токен останется прежним, существующие медиаданные удалятся, переданные медиаданые запишутся.\r\n<p style="color: lightblue">Поле не обязательно для заполнения. Если не заполнено, устанавливается значение `false`</p>',
    )
    kktuCodes: Optional[List[str]] = Field(
        None,
        description="Список кодов ККТУ. Возможные значения кодов ККТУ можно получить через метод `/webapi/v3/dictionaries/kktu`.\r\nДопускаются только коды 3 уровня - \"X.X.X\".\r\nВ настоящий момент список не может содержать более одного значения. Указание нескольких значений станет доступно после введения функционала кобрендинга\r\n<p style=\"color: lightblue\">Поле не обязательно для заполнения</p>",
        example = '["30.1.2", "12.2.3"]'
    )
    mediaData: Optional[List[EditCreativeMediaDataItem]] = Field(
        None,
        description='Медиаданные креатива (массив)\r\n<p style="color: blue">Поле не обязательно для заполнения</p>',
    )
    textData: Optional[List[EditCreativeTextDataItem]] = Field(
        None,
        description='Текстовые медиаданные креатива (массив)\r\n<p style="color: blue">Поле не обязательно '
        'для заполнения</p>',
    )
